VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5850
   ClientLeft      =   225
   ClientTop       =   570
   ClientWidth     =   10560
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   5850
   ScaleWidth      =   10560
   StartUpPosition =   3  'Windows Default
   Begin Proyecto1.ucGallery ucGallery1 
      Height          =   5175
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   6975
      _ExtentX        =   12303
      _ExtentY        =   9128
      BackColor       =   16053492
      BorderRadius    =   0
      ItemsBackColor  =   15790320
      ItemSelBackColor=   16777215
      ItemsShadowColor=   -2147483635
      ItemsShadowOpacity=   20
      ItemsBorderRadius=   8
      ItemsMinWidth   =   300
      ItemsHeight     =   100
      GroupTitleHeight=   0
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Type Items
    Title As String
    Publisher As String
    shortDescription As String
    iconURL As String
    cBitmap As Variant
End Type

Dim mItems() As Items
Dim NumPage As Long
Dim ItemsCount As Long
Dim Margin As Long
Dim IconSize As Long

Private Sub Form_Load()
    IconSize = 40
    Margin = 5
    
    CargarItems
End Sub

Private Sub CargarItems()
    Dim sURL As String
    Dim oXMLHTTP As Object
    Dim cJson As JsonBag
    Dim I As Long
    
    NumPage = NumPage + 1
    sURL = "https://appsource.microsoft.com/view/tiledata/?ReviewsMyCommentsFilter=true&category=machine-learning&country=US&entityType=App&page=" & NumPage
    

    Set oXMLHTTP = CreateObject("Microsoft.XMLHTTP")

    oXMLHTTP.Open "GET", sURL, False
    oXMLHTTP.send

    If oXMLHTTP.Status <> 200 Then Exit Sub
    Set cJson = New JsonBag
    cJson.JSON = oXMLHTTP.responseText
     For I = 1 To cJson.Item("apps").Item("dataList").Count
       
        With cJson.Item("apps").Item("dataList")(I)
            ReDim Preserve mItems(ItemsCount)
            mItems(ItemsCount).Title = .Item("title")
            mItems(ItemsCount).Publisher = .Item("publisher")
            mItems(ItemsCount).shortDescription = .Item("shortDescription")
            mItems(ItemsCount).iconURL = .Item("iconURL")

            ucGallery1.AddItem CStr(ItemsCount)
           
            ItemsCount = ItemsCount + 1
        End With
    Next
    ucGallery1.Refresh
    Set oXMLHTTP = Nothing
    Set cJson = Nothing
End Sub

Private Sub Form_Resize()
    If Me.WindowState <> vbMinimized Then
        ucGallery1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
    End If
End Sub


Private Sub ucGallery1_OnItemPaint(ByVal left As Long, ByVal top As Long, ByVal Width As Long, ByVal Height As Long, ByVal GroupId As Variant, ByVal ItemId As Variant, ByVal IsHotItem As Boolean, ByVal AnimationValue As Single)

    Dim TW As Long, TH As Long

    With ucGallery1
        If IsEmpty(mItems(ItemId).cBitmap) Then
            Set mItems(ItemId).cBitmap = .LoadImage(mItems(ItemId).iconURL)
        End If
    
        .DrawImage mItems(ItemId).cBitmap, left + Margin, top + Margin, IconSize, IconSize, eStretch
    
        .TextColor = vbBlack
        .Font.Name = "Segoe UI Semibold"
        .Font.size = 11
        TW = Width - IconSize - Margin * 3
        TH = ucGallery1.TextHeight(mItems(ItemId).Title)
        .DrawText mItems(ItemId).Title, left + IconSize + Margin * 2, top + Margin, TW, TH, DWRITE_TEXT_ALIGNMENT_LEADING, DWRITE_PARAGRAPH_ALIGNMENT_FAR, False, DWRITE_TRIMMING_GRANULARITY_WORD
    
        .Font.Name = "Segoe UI"
        .Font.size = 10
        .Font.Bold = False
    
        .TextColor = &H525252
    
        TW = Width - IconSize - Margin * 3
        .DrawText mItems(ItemId).Publisher, left + IconSize + Margin * 2, top + Margin * 2 + TH, TW, TH, DWRITE_TEXT_ALIGNMENT_LEADING, DWRITE_PARAGRAPH_ALIGNMENT_FAR, True, DWRITE_TRIMMING_GRANULARITY_CHARACTER
    
        TW = Width - Margin * 3
        TH = Height - Margin * 4 - IconSize
        .DrawText mItems(ItemId).shortDescription, left + Margin * 2, top + Margin * 3 + IconSize, TW, TH, DWRITE_TEXT_ALIGNMENT_LEADING, DWRITE_PARAGRAPH_ALIGNMENT_NEAR, True, DWRITE_TRIMMING_GRANULARITY_CHARACTER
    End With

End Sub

Private Sub ucGallery1_ScrollEnd()
    CargarItems
End Sub

