VERSION 5.00
Begin VB.UserControl ucGallery 
   BackColor       =   &H00FAFAFA&
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4785
   ControlContainer=   -1  'True
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   319
   Begin VB.Timer TimerAnimation 
      Left            =   240
      Top             =   2160
   End
   Begin VB.Timer Timer1 
      Left            =   240
      Top             =   1560
   End
   Begin Proyecto1.ucScrollbar ucScrollbarV 
      Height          =   2535
      Left            =   3720
      Top             =   720
      Visible         =   0   'False
      Width           =   210
      _ExtentX        =   370
      _ExtentY        =   4471
      LargeChange     =   10
      SmoothScrollFactor=   1
      WheelChange     =   27
      BeginProperty ThumbTooltipFont {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Thumbsize_min   =   8
      ScrollWithTimer =   -1  'True
   End
End
Attribute VB_Name = "ucGallery"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
'----------------------------------
'Autor: Leandro Ascierto
'Web: www.leandroascierto.com
'Mail: leandroascierto@hotmail.com
'Date: 21/02/2023
'Gratitude: to The Trick and Fafalone
'            and to everyone who contributed their grain of sand
'Coment: sorry for the mess
'----------------------------------
Private Declare Function PathIsURL Lib "shlwapi.dll" Alias "PathIsURLA" (ByVal pszPath As String) As Long
Private Declare Function VarPtrArray Lib "msvbvm60.dll" Alias "VarPtr" (ptr() As Any) As Long
Private Declare Sub CreateStreamOnHGlobal Lib "Ole32.dll" (ByRef hGlobal As Any, ByVal fDeleteOnRelease As Long, ByRef ppstm As Any)
Private Declare Function CryptStringToBinaryA Lib "crypt32.dll" (ByVal pszString As String, ByVal cchString As Long, ByVal dwFlags As Long, ByVal pbBinary As Long, ByVal pcbBinary As Long, ByVal pdwSkip As Long, ByVal pdwFlags As Long) As Long
Private Declare Sub CopyMemory Lib "Kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As Long)
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As Any, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
Private Declare Function GetObjectType Lib "Gdi32.dll" (ByVal hgdiObj As Long) As Long
Private Declare Function GetObject Lib "GDI32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, lpObject As Any) As Long
Private Declare Function GetSysColor Lib "user32.dll" (ByVal nIndex As Long) As Long
Private Declare Function SetRect Lib "user32" (lpRect As Any, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32.dll" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Private Declare Function GetDeviceCaps Lib "GDI32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Declare Function PtInRect Lib "user32.dll" (ByRef lpRect As RECT, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function DrawTextW Lib "user32.dll" (ByVal hdc As Long, ByVal lpStr As Long, ByVal nCount As Long, ByRef lpRect As RECT, ByVal wFormat As Long) As Long
Private Declare Function LoadCursor Lib "user32" Alias "LoadCursorA" (ByVal hInstance As Long, ByVal lpCursorName As Long) As Long
Private Declare Function DestroyCursor Lib "user32" (ByVal hCursor As Long) As Long
Private Declare Function SetCursor Lib "user32.dll" (ByVal hCursor As Long) As Long
Private Declare Function IntersectRect Lib "user32.dll" (ByRef lpDestRect As RECT, ByRef lpSrc1Rect As RECT, ByRef lpSrc2Rect As RECT) As Long
Private Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Integer
Private Declare Function GetCursorPos Lib "user32.dll" (ByRef lpPoint As POINTAPI) As Long
Private Declare Function ScreenToClient Lib "user32.dll" (ByVal hWnd As Long, ByRef lpPoint As POINTAPI) As Long
Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Private Declare Sub FillMemory Lib "Kernel32.dll" Alias "RtlFillMemory" (ByRef Destination As Any, ByVal Length As Long, ByVal Fill As Byte)

Private Const LOGPIXELSX        As Long = 88
Private Const IDC_HAND          As Long = 32649
Private Const OBJ_BITMAP        As Long = 7
Private Const GENERIC_READ      As Long = &H80000000
Private Const DT_CALCRECT       As Long = &H400
Private Const VER_PLATFORM_WIN32_NT As Long = 2
Private Const VER_NT_WORKSTATION As Long = 1
Private Const VER_MAJORVERSION_WIN7 As Long = 6
Private Const VER_MINORVERSION_WIN7 As Long = 1

'Private Type ICONINFO
'    fIcon           As Long
'    xHotspot        As Long
'    yHotspot        As Long
'    hbmMask         As Long
'    hbmColor        As Long
'End Type

Private Type PicBmp
    size As Long
    type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type

Private Type Bitmap
  bmType                    As Long
  bmWidth                   As Long
  bmHeight                  As Long
  bmWidthBytes              As Long
  bmPlanes                  As Integer
  bmBitsPixel               As Integer
  bmBits                    As Long
End Type

Private Type RECT
    Left As Long
    Top As Long
    right As Long
    bottom As Long
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type OSVERSIONINFO
    dwOSVersionInfoSize As Long
    dwMajorVersion As Long
    dwMinorVersion As Long
    dwBuildNumber As Long
    dwPlatformId As Long
    szCSDVersion As String * 128
End Type


Public Event OnGroupTitlePaint(ByVal hdc As Long, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, ByVal GroupId As Variant, ByVal Title As String, ByVal Description As String, ByVal isHotGroup As Boolean, ByVal AnimationValue As Single)
Public Event GroupClick(ByVal GroupId As Variant)
Public Event GroupDblClick(ByVal GroupId As Variant)
Public Event OnItemPaint(ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long, ByVal GroupId As Variant, ByVal ItemId As Variant, ByVal IsHotItem As Boolean, ByVal AnimationValue As Single)
Public Event ItemClick(ByVal GroupId As Variant, ByVal ItemId As Variant)
Public Event ItemDblClick(ByVal GroupId As Variant, ByVal ItemId As Variant)
Public Event ItemMouseEnter(ByVal GroupId As Variant, ByVal ItemId As Variant, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long)
Public Event ItemMouseExit(ByVal GroupId As Variant, ByVal ItemId As Variant)
Public Event LabelMouseDown(ByVal GroupId As Variant, ByVal ItemId As Variant, ByVal EventId As Variant, ByVal LabelIndex As Long)
Public Event LabelMouseUp(ByVal GroupId As Variant, ByVal ItemId As Variant, ByVal EventId As Variant, ByVal LabelIndex As Long)
Public Event GroupMouseEnter(ByVal GroupId As Variant, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long)
Public Event GroupMouseExit(ByVal GroupId As Variant)
Public Event OnScroll(ByVal GroupId As Variant, ByVal ItemId As Variant, ByVal Left As Long, ByVal Top As Long, ByVal Width As Long, ByVal Height As Long)
Public Event ScrollEnd()
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event DblClick()
Public Event EndPaint()
Public Event AsyncImageLoadComplete(ByVal ImageID As Variant, Url As String, cBitmap As Variant)

Private Type tItem
    id As Variant
    TipText As String
    Columns As Long
    ItemData As Variant
    Selected As Boolean
    bAnimate As Boolean '*
    bIncrese As Boolean '*
    AnimPos As Single '*
    AnimStar As Single
End Type

Private Type Group
    id As Variant
    Title As String
    Description As String
    Items() As tItem
    ItemsCount As Long
    ButtonLeft As RECT
    ButtonRight As RECT
    SliderPos As Long
    Collapse As Boolean
    bAnimate As Boolean '*
    bIncrese As Boolean '*
    AnimPos As Single '*
    AnimStar As Single
End Type

Private Type ItemRegion
    RECT As RECT
    Index As Long
    GroupIndex As Long
End Type

Private Type tSelection
    pStart As POINTAPI
    pEnd As POINTAPI
    bInit As Boolean
End Type

Private Type LabelEvent
    GropuId As Variant
    ItemId As Variant
    EventId As Variant
    Caption As String
    TipText As String
    MouseHand As Boolean
    RECT As RECT
    backColor As Long
    BackColorOpacity As Single
    BorderColor As Long
    BorderWidth As Single
    BorderRadius As Single
    WordWrap As Boolean
    H_TextAlgin As DWRITE_TEXT_ALIGNMENT
    V_TextAlign As DWRITE_PARAGRAPH_ALIGNMENT
    Font As StdFont
    TextColor As Long
    MouseEffect As eMouseEffect
    HighlightColor As Long
End Type

Public Enum eMouseEffect
    NoneEffect
    BorderHighlight
    BackgroundHighlight
    TextHighlight
End Enum

Private Type GroupRegion
    RECT As RECT
    Index As Long
End Type

Public Enum Enum_ViewMode
    VM_GALLERY
    VM_SLIDER
    VM_LIST
End Enum

Public Enum Enum_OnHotItem
    DoNothing
    ColorizeBorder
    InscreaseShadow
    InscreaseBorder
    InscreaseItemSize
End Enum

Public Enum eScaleMode
    eActualSize
    eStretch
    eScaleDown
    eScale
    eScaleUp
End Enum

Public Enum eAnimationSpeed
    AS_None = 0
    AS_SLOW = 1
    AS_MEDIUM = 2
    AS_FAST = 3
End Enum

Dim m_ContainerBkColor      As OLE_COLOR
Dim m_BackColor             As OLE_COLOR
Dim m_BorderColor           As OLE_COLOR
Dim m_BorderWidth           As Integer
Dim m_BorderRadius          As Integer
Dim m_ItemsBackColor        As OLE_COLOR
Dim m_ItemSelBackColor      As OLE_COLOR
Dim m_ItemsShadowColor      As OLE_COLOR
Dim m_ItemsShadowOpacity    As Integer
Dim m_ItemsShadowSize       As Integer
Dim m_ItemsShadowOffsetX    As Integer
Dim m_ItemsShadowOffsetY    As Integer
Dim m_ItemsBorderRadius     As Integer
Dim m_ItemsBorderColor      As OLE_COLOR
Dim m_ItemSelBorderColor    As OLE_COLOR
Dim m_ItemsMargin           As Long
Dim m_ItemsMinWidth         As Long
Dim m_ItemsHeight           As Long
Dim m_ViewMode              As Enum_ViewMode
Dim m_OnHotItem             As Enum_OnHotItem
Dim m_ItemsCusorHand        As Boolean
Dim m_GroupTitleCusorHand   As Boolean
Dim m_DrawItemBackground    As Boolean
Dim m_Enabled               As Boolean
Dim m_Redraw                As Boolean
Dim m_MultiSelect           As Boolean
Dim m_GroupTitleHeight      As Long
Dim m_AnimationSpeed        As eAnimationSpeed
Dim WithEvents m_Font       As StdFont
Attribute m_Font.VB_VarHelpID = -1
Dim ButtonsArrowSize        As Long
Dim mCol                    As Long
Dim mHotItem                As Long
Dim mHotGroup               As Long
Dim mSelItem                As Long
Dim mSelGroup               As Long
Dim mClientWidth            As Long
Dim tGroup()                As Group
Dim tItemRegion()           As ItemRegion
Dim tGroupRegion()          As GroupRegion
Dim ItemRegionCount         As Long
Dim GroupRegionCount        As Long
Dim cGroup                  As Collection
Dim GroupCount              As Long
Dim DpiF                    As Single
Dim hCurHands               As Long
Dim tSel                    As tSelection
Dim cFactory                As ID2D1Factory
Dim cDWFactory              As IDWriteFactory
Dim cRenderTarget           As ID2D1HwndRenderTarget
Dim cSolidBrush             As ID2D1SolidColorBrush
Dim cTextFormat             As IDWriteTextFormat
Dim cTextColorBrush         As ID2D1SolidColorBrush
Dim cWICFactory             As WICImagingFactory
Dim cStroke                 As ID2D1StrokeStyle
Dim cDeviceContext2         As ID2D1DeviceContext2
Dim cImageShadow            As ID2D1Image
Dim m_cEffect               As ID2D1Effect
Dim tLE()                   As LabelEvent
Dim LE_Count                As Long
Dim mHotLabel               As Long
Dim mLastTipText            As String
Dim mCurrentItemRect        As RECT
Dim mAnimateLapse           As Single
Dim bInDraw                 As Boolean
Dim mAnimationMax           As Single
Dim mIsWindows7             As Boolean
Dim nSize                   As Long
Dim cShadowBitmap           As ID2D1Bitmap

Private Function CreateRoundRectImage(Left As Single, Top As Single, Width As Long, Height As Long, Radius As Single, color As Long) As ID2D1Bitmap
    'Dim cWICFactory     As WICImagingFactory
    Dim cWICBitmap      As IWICBitmap
    Dim cMemTarget      As ID2D1RenderTarget
    Dim tRTP            As D2D1_RENDER_TARGET_PROPERTIES
    Dim cBrush          As ID2D1SolidColorBrush
    
    'Set cWICFactory = New WICImagingFactory
    
    Call cWICFactory.CreateBitmap(Width, Height, GUID_WICPixelFormat32bppPBGRA, _
                                    WICBitmapCacheOnDemand, cWICBitmap)
                                
    tRTP.pixelFormat.Format = DXGI_FORMAT_B8G8R8A8_UNORM
    tRTP.pixelFormat.AlphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
 
    Set cMemTarget = cFactory.CreateWicBitmapRenderTarget(ByVal ObjPtr(cWICBitmap), tRTP)

    Set cBrush = cMemTarget.CreateSolidColorBrush(D2D1.ColorF(color, 1#), ByVal 0&)

    cMemTarget.BeginDraw
    
    cMemTarget.FillRoundedRectangle D2D1.RoundedRect(D2D1.RectF(Left, Top, _
                                Width, Height), Radius, Radius), cBrush
                                                          
    cMemTarget.EndDraw ByVal 0&, ByVal 0&
    
    Set CreateRoundRectImage = cRenderTarget.CreateBitmapFromWicBitmap(ByVal ObjPtr(cWICBitmap), ByVal 0&)
End Function


Private Function CreateD2D1ShadowEffect(ByVal cBitmap As ID2D1Bitmap, _
                                       ByRef color As D2D1_VECTOR_4F, _
                                       Optional ByVal standardDeviation As Single = 3, _
                                       Optional ByVal optimation As D2D1_SHADOW_OPTIMIZATION = D2D1_SHADOW_OPTIMIZATION_BALANCED _
                                       ) As ID2D1Image

    Dim bytData() As Byte
    Dim cD2D1Effect As ID2D1Effect

    If standardDeviation < 0 Then standardDeviation = 0
    
    cDeviceContext2.CreateEffect CLSID_D2D1Shadow, cD2D1Effect
    
    cD2D1Effect.SetInput 0&, cBitmap, True
    
    bytData = SingleToByteArray(standardDeviation)
    cD2D1Effect.SetValue D2D1_SHADOW_PROP_BLUR_STANDARD_DEVIATION, D2D1_PROPERTY_TYPE_FLOAT, bytData(0), UBound(bytData) + 1

    bytData = Vector4ToByteArray(color)
    cD2D1Effect.SetValue D2D1_SHADOW_PROP_COLOR, D2D1_PROPERTY_TYPE_VECTOR4, bytData(0), UBound(bytData) + 1
        
    bytData = LongToByteArray(optimation)
    cD2D1Effect.SetValue D2D1_SHADOW_PROP_OPTIMIZATION, D2D1_PROPERTY_TYPE_ENUM, bytData(0), UBound(bytData) + 1

    Call cD2D1Effect.GetOutput(CreateD2D1ShadowEffect)

End Function

Private Function SingleToByteArray(ByVal Value As Single) As Byte()
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(Value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), Value, lngDataSize)
    SingleToByteArray = bytData
End Function

Private Function LongToByteArray(ByVal Value As Long) As Byte()
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(Value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), Value, lngDataSize)
    LongToByteArray = bytData
End Function

Private Function Vector4ToByteArray(ByRef Value As D2D1_VECTOR_4F) As Byte()
    Dim bytData() As Byte
    Dim lngDataSize As Long
    lngDataSize = LenB(Value)
    ReDim bytData(lngDataSize - 1)
    Call CopyMemory(bytData(0), Value, lngDataSize)
    Vector4ToByteArray = bytData
End Function

Public Function CLSID_D2D1Shadow() As UUID
    Static IID As UUID
     If (IID.Data1 = 0) Then Call DEFINE_UUID(IID, &HC67EA361, &H1863, &H4E69, &H89, &HDB, &H69, &H5D, &H3E, &H9A, &H5B, &H6B)
    CLSID_D2D1Shadow = IID
End Function

Public Sub DEFINE_UUID(Name As UUID, L As Long, w1 As Integer, w2 As Integer, B0 As Byte, b1 As Byte, b2 As Byte, B3 As Byte, b4 As Byte, b5 As Byte, b6 As Byte, b7 As Byte)
  With Name
    .Data1 = L
    .Data2 = w1
    .Data3 = w2
    .Data4(0) = B0
    .Data4(1) = b1
    .Data4(2) = b2
    .Data4(3) = B3
    .Data4(4) = b4
    .Data4(5) = b5
    .Data4(6) = b6
    .Data4(7) = b7
  End With
End Sub

Public Sub DrawLine(ByVal X1 As Single, ByVal Y1 As Single, _
                    ByVal X2 As Single, ByVal Y2 As Single, _
            ByVal oColor As Long, Optional ByVal Opacity As Single = 1, _
            Optional ByVal PenWidth As Single = 1, _
            Optional ByVal DashStyle As D2D1_DASH_STYLE = D2D1_DASH_STYLE_SOLID)
     
     Dim cStroke As ID2D1StrokeStyle

     Set cStroke = cFactory.CreateStrokeStyle(D2D1.StrokeStyleProperties(D2D1_CAP_STYLE_ROUND, _
                    D2D1_CAP_STYLE_ROUND, D2D1_CAP_STYLE_FLAT, D2D1_LINE_JOIN_MITER, , _
                    DashStyle), ByVal 0&, 0)
            
    cSolidBrush.SetColor D2D1.ColorF3(oColor, Opacity)
    cRenderTarget.DrawLine X1, Y1, X2, Y2, cSolidBrush, PenWidth, cStroke
 End Sub
 
 Public Sub DrawRoundRectangle(ByVal Left As Single, ByVal Top As Single, _
                    ByVal Width As Single, ByVal Height As Single, _
            Optional ByVal backColor As Long = -1, Optional ByVal BackColorOpacity As Single = 1, _
            Optional ByVal BorderColor As Single = -1, Optional ByVal BorderColorOpacity As Single = 1, _
            Optional ByVal BorderWidth As Single = 1, Optional BorderRadius As Single = 0)
    Dim RectF As D2D1_RECT_F
    RectF = D2D1.RectF(Left, Top, Left + Width, Top + Height)
    
    If backColor <> -1 Then
        cSolidBrush.SetColor D2D1.ColorF3(backColor, BackColorOpacity)
        cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(RectF, BorderRadius, BorderRadius), cSolidBrush
    End If
    
    If BorderColor <> -1 Then
        cSolidBrush.SetColor D2D1.ColorF3(BorderColor, BorderColorOpacity)
        cRenderTarget.DrawRoundedRectangle D2D1.RoundedRect(RectF, BorderRadius, BorderRadius), cSolidBrush, BorderWidth, cStroke
    End If
 End Sub
 
Private Sub DrawLabelEffect(Index As Long, MouseIn As Boolean, Optional OpenDraw As Boolean = True)
    On Error Resume Next
    
    Dim NewColor As Long
    Dim BkColor As Long
    
    With tLE(Index)
        Dim RectF As D2D1_RECT_F
        RectF = D2D1.RectF(.RECT.Left, .RECT.Top, .RECT.right, .RECT.bottom)
        
        BkColor = IIf(Me.SelItem = HotItem, Me.ItemSelBackColor, Me.backColor)
        
        If OpenDraw Then cRenderTarget.BeginDraw
        Select Case .MouseEffect
        
            Case BorderHighlight
            
                If MouseIn Then
                    If .HighlightColor <> -1 Then
                        NewColor = .HighlightColor
                    Else
                        NewColor = ShiftColor(.BorderColor, vbWhite, 100)
                    End If
                Else
                    If .BorderColor <> -1 Then
                        NewColor = .BorderColor
                    Else
                        NewColor = BkColor
                    End If
                End If

               cSolidBrush.SetColor D2D1.ColorF3(NewColor, .BackColorOpacity)
               cRenderTarget.DrawRoundedRectangle D2D1.RoundedRect(RectF, .BorderRadius, .BorderRadius), cSolidBrush, .BorderWidth, cStroke
            
            
            Case BackgroundHighlight
                If MouseIn Then
                    If .HighlightColor <> -1 Then
                        NewColor = .HighlightColor
                    Else
                        NewColor = ShiftColor(.backColor, vbWhite, 170)
                    End If
                Else
                    If .backColor <> -1 Then
                        NewColor = .backColor
                    Else
                        NewColor = BkColor
                    End If
                End If
                
                cSolidBrush.SetColor D2D1.ColorF3(NewColor, .BackColorOpacity)
                cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(RectF, .BorderRadius, .BorderRadius), cSolidBrush

                If Len(.Caption) Then
                    Dim mFont As StdFont
                    CloneFont Me.Font, mFont
                    CloneFont .Font, Me.Font
                    
                    Me.TextColor = .TextColor
        
                    Dim M As Single
                    If .H_TextAlgin <> DWRITE_TEXT_ALIGNMENT_CENTER Then
                       M = Me.TextWidth(Space$(1)) + .BorderWidth
                    End If
        
                    DrawText .Caption, .RECT.Left + M, .RECT.Top, .RECT.right - .RECT.Left - M * 2, .RECT.bottom - .RECT.Top, .H_TextAlgin, .V_TextAlign, .WordWrap
                    CloneFont mFont, Me.Font
                    
                End If
            Case TextHighlight
            
                If MouseIn Then
                    If .HighlightColor <> -1 Then
                        NewColor = .HighlightColor
                    Else
                        NewColor = ShiftColor(.TextColor, vbBlue, 10)
                    End If
                Else
                    NewColor = .TextColor
                End If

                If .backColor <> -1 Then BkColor = .backColor
                
                cSolidBrush.SetColor D2D1.ColorF3(BkColor, .BackColorOpacity)
                cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(RectF, .BorderRadius, .BorderRadius), cSolidBrush
                
                
                If Len(.Caption) Then
                
                    CloneFont Me.Font, mFont
                    CloneFont .Font, Me.Font
                    
                    Me.TextColor = NewColor
        
                    If .H_TextAlgin <> DWRITE_TEXT_ALIGNMENT_CENTER Then
                       M = Me.TextWidth(Space$(1)) + .BorderWidth
                    End If
        
                    DrawText .Caption, .RECT.Left + M, .RECT.Top, .RECT.right - .RECT.Left - M * 2, .RECT.bottom - .RECT.Top, .H_TextAlgin, .V_TextAlign, .WordWrap
                    CloneFont mFont, Me.Font
                    
                End If

        End Select

        
        If OpenDraw Then cRenderTarget.EndDraw ByVal 0&, ByVal 0&
        
    End With
End Sub

Private Sub CloneFont(Font1 As StdFont, Font2 As StdFont)
    If Font2 Is Nothing Then Set Font2 = New StdFont
    With Font2
        .Name = Font1.Name
        .Bold = Font1.Bold
        .Charset = Font1.Charset
        .size = Font1.size
        .Strikethrough = Font1.Strikethrough
        .Underline = Font1.Underline
        .Weight = Font1.Weight
        .Italic = Font1.Italic
    End With
End Sub

Public Sub AddLabelEvent(ByVal Left As Single, ByVal Top As Single, _
        Optional ByVal Width As Single, Optional ByVal Height As Single, _
        Optional GroupId As Variant, Optional ItemId As Variant, _
        Optional EventId As Variant, Optional ByVal Caption As String, _
        Optional ByVal backColor As Long = -1, Optional ByVal BackColorOpacity As Single = 1, _
        Optional ByVal BorderColor As Long = -1, _
        Optional ByVal BorderRadius As Single = 0, Optional ByVal BorderWidth As Single = 1, _
        Optional ByVal MouseHands As Boolean = True, Optional ByVal TipText As String, Optional ByVal WordWrap As Boolean, _
        Optional H_TextAlgin As DWRITE_TEXT_ALIGNMENT = DWRITE_TEXT_ALIGNMENT_CENTER, _
        Optional V_TextAlign As DWRITE_PARAGRAPH_ALIGNMENT = DWRITE_PARAGRAPH_ALIGNMENT_CENTER, _
        Optional MouseEffect As eMouseEffect, _
        Optional HighlightColor As Long = -1)

    Dim RectF As D2D1_RECT_F
    
    If Width = 0 Then Width = Me.TextWidth(Caption & Space$(2))
    If Height = 0 Then Height = Me.TextHeight(Caption & Space$(2))
    
    RectF = D2D1.RectF(Left, Top, Left + Width, Top + Height)
    
    ReDim Preserve tLE(LE_Count)
    With tLE(LE_Count)
        .Caption = Caption
        .EventId = EventId
        .GropuId = GroupId
        .ItemId = ItemId
        With .RECT
            .Left = Left
            .Top = Top
            .right = Left + Width
            .bottom = Top + Height
        End With
        .MouseHand = MouseHands
        .TipText = TipText
        .backColor = backColor
        .BackColorOpacity = BackColorOpacity
        .BorderColor = BorderColor
        .BorderWidth = BorderWidth
        .BorderRadius = BorderRadius
        .WordWrap = WordWrap
        .H_TextAlgin = H_TextAlgin
        .V_TextAlign = V_TextAlign
        CloneFont m_Font, .Font
        .TextColor = Me.TextColor
        .MouseEffect = MouseEffect
        .HighlightColor = HighlightColor
    End With
    
    LE_Count = LE_Count + 1

    If backColor <> -1 Then
        cSolidBrush.SetColor D2D1.ColorF3(backColor, BackColorOpacity)
        cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(RectF, BorderRadius, BorderRadius), cSolidBrush
    End If
    
    If BorderColor <> -1 Then
        cSolidBrush.SetColor D2D1.ColorF3(BorderColor, BackColorOpacity)
        cRenderTarget.DrawRoundedRectangle D2D1.RoundedRect(RectF, BorderRadius, BorderRadius), cSolidBrush, BorderWidth, cStroke
    End If

    If Len(Caption) Then
        Dim M As Single
        If H_TextAlgin <> DWRITE_TEXT_ALIGNMENT_CENTER Then
           M = Me.TextWidth(Space$(1)) + BorderWidth
        End If
    
        DrawText Caption, Left + M, Top, Width - M * 2, Height, H_TextAlgin, V_TextAlign, WordWrap
    End If
    
    Dim PT As POINTAPI

    GetCursorPos PT
    ScreenToClient UserControl.hWnd, PT

    If PtInRect(tLE(LE_Count - 1).RECT, PT.X / DpiF, PT.Y / DpiF) And MouseEffect <> NoneEffect Then
        DrawLabelEffect LE_Count - 1, True, False
    End If

End Sub

Private Sub TimerAnimation_Timer()
    Dim I As Long, J As Long
    Dim bFlag As BOOL
    Dim F As Single
    
    For J = 0 To GroupCount - 1
        With tGroup(J)
            '----------
            If .bAnimate Then
                bFlag = True
                If .bIncrese Then
                    F = (mAnimateLapse - (.AnimStar - Timer)) / mAnimateLapse
                    .AnimPos = mAnimationMax * F
                    If .AnimPos >= mAnimationMax Then
                        .AnimPos = mAnimationMax
                        .bAnimate = False
                    End If
                Else
                    F = ((.AnimStar - Timer)) / mAnimateLapse
                    
                    .AnimPos = mAnimationMax * F
                    If .AnimPos >= mAnimationMax Then .AnimPos = mAnimationMax
                    If .AnimPos <= 0 Then
                        .AnimPos = 0
                        .bAnimate = False
                    End If
                End If
            Else
                If mHotGroup <> J Then .AnimPos = 0
            End If
            '----------
            
            If .SliderPos < 0 Then .SliderPos = 0
            For I = .SliderPos To .ItemsCount - 1
                If .Items(I).bAnimate Then
                    bFlag = True
                    If .Items(I).bIncrese Then
                        
                        F = (mAnimateLapse - (.Items(I).AnimStar - Timer)) / mAnimateLapse
                        .Items(I).AnimPos = mAnimationMax * F
                        If .Items(I).AnimPos >= mAnimationMax Then
                            .Items(I).AnimPos = mAnimationMax
                            .Items(I).bAnimate = False
                        End If
                    Else
                        F = ((.Items(I).AnimStar - Timer)) / mAnimateLapse
                        .Items(I).AnimPos = mAnimationMax * F
                        If .Items(I).AnimPos >= mAnimationMax Then .Items(I).AnimPos = mAnimationMax
                        If .Items(I).AnimPos <= 0 Then
                            .Items(I).AnimPos = 0
                            .Items(I).bAnimate = False
                        End If
                    End If
                End If
            Next
        End With
    Next
    Draw
    If bFlag Then Exit Sub
    TimerAnimation.Interval = 0
End Sub

Private Sub UserControl_Initialize()
    DpiF = GetWindowsDPI
    
    hCurHands = LoadCursor(ByVal 0&, IDC_HAND)
    
    Set cGroup = New Collection
    
    mAnimateLapse = 0.25
    mHotItem = -1
    mHotGroup = -1
    mHotLabel = -1
    mSelItem = -1
    mSelGroup = -1
    
    m_ItemsMargin = 1 'previene division por cero en (windows 11 pro)
    
    tSel.pStart.X = -1
    tSel.pStart.Y = -1
    tSel.pEnd.X = -1
    tSel.pEnd.Y = -1
    m_Redraw = True
End Sub

Public Property Get GroupsCount() As Long
    GroupsCount = GroupCount
End Property

Public Sub GroupRemoveItemByID(GroupId As Variant, ItemId As Long)
    Dim I As Long, Index As Long
    
    Index = -1
    
    With tGroup(cGroup(GroupId))
        For I = 0 To .ItemsCount - 1
            If ItemId = .Items(I).id Then
                Index = I
                Exit For
            End If
        Next
    End With
    
    If Index <> -1 Then
        GroupRemoveItemByIndex GroupId, Index
    Else
        Err.Raise 100, "the id number does not exist"
    End If
End Sub

Public Sub GroupRemoveItemByIndex(GroupId As Variant, ItemIndex As Long)
    Dim I As Long
    
    With tGroup(cGroup(GroupId))
        If ItemIndex < 0 Or ItemIndex > .ItemsCount - 1 Then
            Err.Raise 101, "the Index is out of range"
            Exit Sub
        End If
        For I = ItemIndex To .ItemsCount - 2
            .Items(I) = .Items(I + 1)
        Next
        .ItemsCount = .ItemsCount - 1
        ReDim Preserve .Items(.ItemsCount - 1)
    End With
    mHotItem = -1
    mHotGroup = -1
    mSelItem = -1
    mSelGroup = -1
    UserControl_Resize
End Sub

Public Sub RemoveGroup(GroupId As Variant)
    Dim I As Long
 
    For I = cGroup(GroupId) To GroupCount - 2
        tGroup(I) = tGroup(I + 1)
    Next
    GroupCount = GroupCount - 1
    
    If GroupCount > 0 Then
        ReDim Preserve tGroup(GroupCount - 1)
    End If
    
    Set cGroup = New Collection
    For I = 0 To GroupCount - 1
        cGroup.Add I, tGroup(I).id
    Next
    mHotItem = -1
    mHotGroup = -1
    mSelItem = -1
    mSelGroup = -1
    UserControl_Resize
End Sub

Public Sub Clear()
    Dim I As Long

    For I = 0 To GroupCount - 1
        With tGroup(I)
            ReDim .Items(0)
            .ItemsCount = 0
            .SliderPos = 0
            SetRect .ButtonLeft, 0&, 0&, 0&, 0&
            SetRect .ButtonRight, 0&, 0&, 0&, 0&
        End With
    Next
    
    mHotItem = -1
    mHotGroup = -1
    mSelItem = -1
    mSelGroup = -1
    UserControl_Resize
End Sub


Public Sub ClearGroup(GroupId As Variant)
    Dim GroupIndex As Long
    If cGroup.Count = 0 Then
        If GroupCount = 0 Then Exit Sub
        GroupIndex = 0
    Else
        GroupIndex = cGroup(GroupId)
    End If
    With tGroup(GroupIndex)
        ReDim .Items(0)
        .ItemsCount = 0
        .SliderPos = 0
        SetRect .ButtonLeft, 0&, 0&, 0&, 0&
        SetRect .ButtonRight, 0&, 0&, 0&, 0&
    End With
    
    mHotItem = -1
    mHotGroup = -1
    mSelItem = -1
    mSelGroup = -1
    UserControl_Resize
End Sub

Public Property Let GroupCollapse(GroupId As Variant, NewValue As Boolean)
    Dim GroupIndex As Long
    If cGroup.Count = 0 Then
        If GroupCount = 0 Then Exit Property
        GroupIndex = 0
    Else
        GroupIndex = cGroup(GroupId)
    End If
    tGroup(GroupIndex).Collapse = NewValue
    
    UserControl_Resize
End Property

Public Property Get GroupCollapse(GroupId As Variant) As Boolean
    Dim GroupIndex As Long
    If cGroup.Count = 0 Then
        If GroupCount = 0 Then Exit Property
        GroupIndex = 0
    Else
        GroupIndex = cGroup(GroupId)
    End If
    GroupCollapse = tGroup(GroupIndex).Collapse
End Property

Public Sub AddGroup(id As Variant, Optional ByVal Title As String, Optional ByVal Description As String)
    ReDim Preserve tGroup(GroupCount)
    cGroup.Add GroupCount, id
    With tGroup(GroupCount)
        .id = id
        .Title = Title
        .Description = Description
    End With
    GroupCount = GroupCount + 1
End Sub

Public Property Get ItemData(GroupId As Variant, ItemId As Variant) As Variant
    Dim I As Long
    For I = 0 To tGroup(cGroup(GroupId)).ItemsCount - 1
        If tGroup(cGroup(GroupId)).Items(I).id = ItemId Then
            ItemData = tGroup(cGroup(GroupId)).Items(I).ItemData
            Exit Property
        End If
    Next
End Property

Public Property Let ItemData(GroupId As Variant, ItemId As Variant, NewValue As Variant)
    Dim I As Long
    For I = 0 To tGroup(cGroup(GroupId)).ItemsCount - 1
        If tGroup(cGroup(GroupId)).Items(I).id = ItemId Then
            tGroup(cGroup(GroupId)).Items(I).ItemData = NewValue
            Exit Property
        End If
    Next
End Property

Public Property Get GroupItemsCount(GroupId As Variant) As Long
    GroupItemsCount = tGroup(cGroup(GroupId)).ItemsCount
End Property

Public Property Get GroupTitle(GroupId As Variant) As String
    GroupTitle = tGroup(cGroup(GroupId)).Title
End Property

Public Property Let GroupTitle(GroupId As Variant, ByVal NewValue As String)
    tGroup(cGroup(GroupId)).Title = NewValue
End Property

Public Property Let GroupDescription(GroupId As Variant, ByVal NewValue As String)
    tGroup(cGroup(GroupId)).Description = NewValue
End Property

Public Property Get GroupDescription(GroupId As Variant) As String
    GroupDescription = tGroup(cGroup(GroupId)).Description
End Property

Public Sub AddItem(id As Variant, Optional TipText As String, Optional GroupId As Variant, Optional Columns As Long = 1, Optional ItemData As Variant)
    If IsMissing(GroupId) Then
        If GroupCount = 0 Then
            ReDim tGroup(GroupCount)
            GroupCount = 1
        End If
        
        With tGroup(GroupCount - 1)
            ReDim Preserve .Items(.ItemsCount)
            With .Items(.ItemsCount)
                .id = id
                .TipText = TipText
                .Columns = Columns
                .ItemData = ItemData
            End With
            .ItemsCount = .ItemsCount + 1
        End With
        
    Else
        With tGroup(cGroup(GroupId))
            ReDim Preserve .Items(.ItemsCount)
            With .Items(.ItemsCount)
                .id = id
                .TipText = TipText
                .Columns = Columns
                .ItemData = ItemData
            End With
            .ItemsCount = .ItemsCount + 1
        End With
    End If
End Sub


Private Function ColorToVector_4F(ByVal eColor As Long, _
                Optional ByVal fAlpha As Single = 1!) As D2D1_VECTOR_4F
    Dim bR As Byte
    Dim bB As Byte
    Dim bG As Byte
    
    If (eColor And &H80000000) Then eColor = GetSysColor(eColor And &HFF&)
    
    bB = (eColor \ &H10000) And &HFF
    bG = (eColor \ &H100) And &HFF
    bR = eColor And &HFF

    With ColorToVector_4F
        .X = bR / 255!
        .Y = bG / 255!
        .z = bB / 255!
        .w = fAlpha
    End With

End Function

'*1
Private Sub Draw()
    Dim I As Long, J As Long
    Dim X As Long, Y As Long, w As Long, h As Long
    Dim ItemWidth As Long
    Dim IH As Long
    Dim APos As Long
    Dim SSZ As Long
    Dim IM As Long
    Dim IW As Long
    Dim HotItem As Long, HotGroup As Long
    Dim BorderColor As Long
    Dim BorderWidth As Single
    Dim IBkColor As Long
    Dim SelRect As RECT
    Dim ItemRect As RECT
    Dim R As RECT
    Dim KeyCtrlPressed As Boolean
    Dim RectF As D2D1_RECT_F
    Dim cBitmapShadow           As ID2D1Bitmap
    Dim AnimationValue As Single
    Dim LastSize As Long
    
    If bInDraw Then Exit Sub
    If m_Redraw = False Then Exit Sub
    If cRenderTarget Is Nothing Then Exit Sub

    If tSel.bInit Then
        With SelRect
            .Left = IIf(tSel.pStart.X < tSel.pEnd.X, tSel.pStart.X, tSel.pEnd.X)
            .Top = IIf(tSel.pStart.Y < tSel.pEnd.Y, tSel.pStart.Y, tSel.pEnd.Y) - ucScrollbarV.Value
            .right = IIf(tSel.pStart.X < tSel.pEnd.X, tSel.pEnd.X, tSel.pStart.X)
            .bottom = IIf(tSel.pStart.Y < tSel.pEnd.Y, tSel.pEnd.Y, tSel.pStart.Y) - ucScrollbarV.Value
        End With
    End If
    
    If LE_Count > 0 Then
        ReDim tLE(0)
        LE_Count = 0
    End If
    
    bInDraw = True
    cRenderTarget.BeginDraw
    
    If m_BorderWidth > 0 Then
        cRenderTarget.Clear D2D1.ColorF3(m_ContainerBkColor)
        
        RectF = D2D1.RectF(0, 0, UserControl.ScaleWidth / DpiF, UserControl.ScaleHeight / DpiF)
        cSolidBrush.SetColor D2D1.ColorF3(m_BackColor, 1)
        cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(RectF, m_BorderRadius, m_BorderRadius), cSolidBrush
        
    Else
        cRenderTarget.Clear D2D1.ColorF3(m_BackColor)
    End If
    
    
    KeyCtrlPressed = CBool(GetKeyState(vbKeyControl) < 0)

    IM = m_ItemsMargin '* DpiF
    IH = m_ItemsHeight '* DpiF
    mClientWidth = UserControl.ScaleWidth - IIf(ucScrollbarV.Visible, ucScrollbarV.Width, 0) - DpiF * 2
    mCol = mClientWidth \ ((m_ItemsMinWidth + m_ItemsMargin) * DpiF)

    If mCol = 0 Then mCol = 1
    ItemWidth = (mClientWidth - (mCol + 1) * IM * DpiF) / mCol / DpiF
    SSZ = m_ItemsShadowSize
    Y = IM - ucScrollbarV.Value
    
    If mHotItem <> -1 And mHotItem < ItemRegionCount Then
        HotItem = tItemRegion(mHotItem).Index
        HotGroup = tItemRegion(mHotItem).GroupIndex
    Else
        HotItem = -1
        HotGroup = -1
    End If
    
    ItemRegionCount = 0
    GroupRegionCount = 0
    
    If m_DrawItemBackground Then
        For J = 0 To GroupCount - 1
            With tGroup(J)
                If m_GroupTitleHeight > 0 Then Y = Y + (m_GroupTitleHeight + m_ItemsMargin) '* DpiF
                If .Collapse = False Then
                    
                    X = IM
                    

                    If tGroup(J).SliderPos < 0 Then tGroup(J).SliderPos = 0
                    For I = tGroup(J).SliderPos To .ItemsCount - 1

                        If tSel.bInit Then
                            SetRect ItemRect, X, Y, X + ItemWidth, Y + m_ItemsHeight
                            
                            If KeyCtrlPressed Then
                                If IntersectRect(R, ItemRect, SelRect) Then
                                    .Items(I).Selected = Not .Items(I).Selected
                                End If
                            Else
                                .Items(I).Selected = IntersectRect(R, ItemRect, SelRect)
                            End If
                        End If
                        
                        If m_ViewMode = VM_GALLERY Then
                            IW = (ItemWidth) * .Items(I).Columns + IM * (.Items(I).Columns - 1)
        
                            Do While X + IW >= mClientWidth / DpiF
                                IW = IW - ItemWidth - IM
                            Loop
                            
                        ElseIf m_ViewMode = VM_SLIDER Then
                            IW = ItemWidth
                        Else
                            IW = mClientWidth / DpiF - IM * 2
                        End If
                    
                        If Y + IH > 0 Then
                            BorderColor = m_ItemsBorderColor
                            IBkColor = m_ItemsBackColor
                            BorderWidth = 1
                            SSZ = m_ItemsShadowSize
                            
                            If m_OnHotItem = ColorizeBorder Then
                                BorderColor = ShiftColor(m_ItemSelBorderColor, m_ItemsBorderColor, .Items(I).AnimPos)
                            End If
                            
                            If m_OnHotItem = InscreaseBorder Then
                                BorderWidth = 1 + .Items(I).AnimPos
                            End If
                                                    
                            If m_MultiSelect Then
                                If (mSelGroup = J And mSelItem = I) Or .Items(I).Selected = True Then
                                    BorderColor = m_ItemSelBorderColor
                                End If
                                
                                If (mSelGroup = J And mSelItem = I) Then
                                    BorderWidth = 2
                                End If
                                
                                If .Items(I).Selected Then
                                    IBkColor = m_ItemSelBackColor
                                End If
                                
                                
                            Else
                                If (mSelGroup = J And mSelItem = I) Then
                                    BorderColor = m_ItemSelBorderColor
                                    IBkColor = m_ItemSelBackColor
                                End If
                            End If
                            
                            If m_ItemsShadowSize > 0 And m_ItemsShadowOpacity > 0 Then
                                If mIsWindows7 Then
                                    If m_OnHotItem = InscreaseShadow Or m_OnHotItem = InscreaseItemSize Then
                                        APos = SSZ + .Items(I).AnimPos
                                    Else
                                        APos = SSZ
                                    End If
                                    '*******************
                                    RenderStretch X - APos + (m_ItemsShadowOffsetX), Y - APos + (m_ItemsShadowOffsetY), IW + APos * 2, IH + APos * 2, 0, 0, (nSize / DpiF + m_ItemsShadowSize * 2), (nSize / DpiF + m_ItemsShadowSize * 2), (m_ItemsShadowSize * 2 + m_ItemsBorderRadius)
                                    '*******************
                                Else
                                    If m_OnHotItem = InscreaseShadow Or m_OnHotItem = InscreaseItemSize Then
                                        APos = .Items(I).AnimPos 'SSZ + .Items(I).AnimPos
                                    Else
                                        APos = 0 'SSZ
                                    End If
    
                                    If LastSize <> IW + APos Then
                                        LastSize = IW + APos
                                        Set cImageShadow = Nothing
                                    End If
                                    
    '*************************************************
                                    If cImageShadow Is Nothing Then
                                        Set cBitmapShadow = CreateRoundRectImage((APos + m_ItemsShadowSize) * 2.5 * DpiF, (APos + m_ItemsShadowSize) * 2.5 * DpiF, _
                                                        (IW + APos * 2) * DpiF, (IH + APos * 2) * DpiF, m_ItemsBorderRadius / 2 / DpiF, vbBlack)
                                                        
                                                        
                                        Set cImageShadow = CreateD2D1ShadowEffect(cBitmapShadow, ColorToVector_4F(m_ItemsShadowColor, 5 * m_ItemsShadowOpacity / 100), m_ItemsShadowSize + APos)
                                    End If
                                
                                    cDeviceContext2.DrawImage cImageShadow, D2D1.Point2F(X - APos + (m_ItemsShadowOffsetX) - (APos + m_ItemsShadowSize) * 2.5 / 2, Y - APos + (m_ItemsShadowOffsetY) - (APos + m_ItemsShadowSize) * 2.5 / 2), D2D1.RectF(0, 0, IW * 2, IH * 2), D2D1_INTERPOLATION_MODE_LINEAR, D2D1_COMPOSITE_MODE_SOURCE_OVER
    '**************************************************
                                End If
                            End If
                            
                            cSolidBrush.SetColor D2D1.ColorF3(IBkColor, 1)
                            If m_OnHotItem = InscreaseItemSize Then
                                APos = .Items(I).AnimPos
                            Else
                                APos = 0
                            End If
                            
                            RectF = D2D1.RectF(X - APos, Y - APos, X + IW + APos, Y + IH + APos)
                            cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(RectF, m_ItemsBorderRadius, m_ItemsBorderRadius), cSolidBrush
                            
                            cSolidBrush.SetColor D2D1.ColorF3(BorderColor, 0.5)
                            cRenderTarget.DrawRoundedRectangle D2D1.RoundedRect(RectF, m_ItemsBorderRadius, m_ItemsBorderRadius), cSolidBrush, BorderWidth, cStroke
                        End If
                        
                        If m_ViewMode = VM_LIST Then
                            If I < .ItemsCount - 1 Then Y = Y + IH + IM
                            If Y > UserControl.ScaleHeight Then Exit For
                        Else
                            If X + IW + (m_ItemsMargin + m_ItemsMinWidth / 2) >= mClientWidth / DpiF Then
                                If m_ViewMode = VM_GALLERY Then
                                    X = IM
                                    If I < .ItemsCount - 1 Then Y = Y + IH + IM
                                    
                                    If Y > UserControl.ScaleHeight Then Exit For
                                ElseIf m_ViewMode = VM_SLIDER Then
                                    Exit For
                                End If
                            Else
                                X = X + IW + IM
                            End If
                        End If
                        
                    Next
        
                    If .ItemsCount > 0 Then Y = Y + IH + IM
                End If
            End With
            If Y > UserControl.ScaleHeight Then Exit For
        Next

    End If
'******************

    Y = IM - ucScrollbarV.Value
    
    For J = 0 To GroupCount - 1
        With tGroup(J)
            X = IM
            
            ReDim Preserve tGroupRegion(GroupRegionCount)
            With tGroupRegion(GroupRegionCount)
                SetRect .RECT, X, Y, X + mClientWidth - IM * 2, Y + m_GroupTitleHeight '* DpiF
                .Index = J
            End With
            
            GroupRegionCount = GroupRegionCount + 1
            If m_GroupTitleHeight > 0 Then
                '********************************
                
                AnimationValue = Round(.AnimPos / mAnimationMax, 2)
                RaiseEvent OnGroupTitlePaint(hdc, X, Y, mClientWidth / DpiF - IM * 2, m_GroupTitleHeight, .id, .Title, .Description, CBool(mHotGroup = J), AnimationValue)
                '********************************
                Y = Y + (m_GroupTitleHeight + m_ItemsMargin) '* DpiF
            End If
            If .Collapse = False Then
                If tGroup(J).SliderPos < 0 Then tGroup(J).SliderPos = 0
                For I = tGroup(J).SliderPos To .ItemsCount - 1
                    
                    If tSel.bInit And m_DrawItemBackground = False Then
                        SetRect ItemRect, X, Y, X + ItemWidth, Y + m_ItemsHeight
                        .Items(I).Selected = IntersectRect(R, ItemRect, SelRect)
                    End If
       
                    If m_ViewMode = VM_GALLERY Then
                        IW = (ItemWidth) * .Items(I).Columns + IM * (.Items(I).Columns - 1)
    
                        Do While X + IW >= mClientWidth / DpiF
                            IW = IW - ItemWidth - IM
                        Loop
                        
                    ElseIf m_ViewMode = VM_SLIDER Then
                        IW = ItemWidth
                    Else
                        IW = mClientWidth / DpiF - IM * 2
                    End If
                
                    If Y + IH > 0 Then
                        
                        If m_OnHotItem = InscreaseItemSize Then
                            APos = .Items(I).AnimPos
                        Else
                            APos = 0
                        End If
                        
                        ReDim Preserve tItemRegion(ItemRegionCount)
                        With tItemRegion(ItemRegionCount)
                            SetRect .RECT, X + 1 - APos, Y + 1 - APos, X + IW - 2 + APos, Y + IH - 2 + APos
                            .Index = I
                            .GroupIndex = J
                            mCurrentItemRect = .RECT
                        End With
                        ItemRegionCount = ItemRegionCount + 1
                        If IW > 0 Then
                            '********************************
                            
                            AnimationValue = Round(.Items(I).AnimPos / mAnimationMax, 2)
                            RaiseEvent OnItemPaint(X - APos, Y - APos, IW + APos * 2, IH + APos * 2, tGroup(J).id, tGroup(J).Items(I).id, CBool((HotGroup = J And HotItem = I)), AnimationValue)
                            '********************************
                        End If
                    End If
                    
                    If m_ViewMode = VM_LIST Then
                        If I < .ItemsCount - 1 Then Y = Y + IH + IM
                        If Y > UserControl.ScaleHeight Then Exit For
                    Else
                        If X + IW + (m_ItemsMargin + m_ItemsMinWidth / 2) >= mClientWidth / DpiF Then
                            If m_ViewMode = VM_GALLERY Then
                                X = IM
                                If I < .ItemsCount - 1 Then Y = Y + IH + IM
                                If Y > UserControl.ScaleHeight Then Exit For
                            ElseIf m_ViewMode = VM_SLIDER Then
                                Dim lTop As Long
                                
                                lTop = Y + IH / 2 - ButtonsArrowSize / 2
                                If .SliderPos > 0 Then
                                    X = IM - ButtonsArrowSize / 2
                                    If X < 0 Then X = 0
                                    SetRect .ButtonLeft, X * DpiF, lTop * DpiF, (X + ButtonsArrowSize) * DpiF, (lTop + ButtonsArrowSize) * DpiF
                                     '********************************
                                    DrawArrowLeft X, lTop
                                Else
                                    SetRect .ButtonRight, 0&, 0&, 0&, 0&
                                End If
                                
                                If .SliderPos < .ItemsCount - mCol Then
                                
                                    X = mClientWidth / DpiF - IM - ButtonsArrowSize / 2
                                    If X + ButtonsArrowSize > mClientWidth / DpiF Then X = mClientWidth / DpiF - ButtonsArrowSize
                                    SetRect .ButtonRight, X * DpiF, lTop * DpiF, (X + ButtonsArrowSize) * DpiF, (lTop + ButtonsArrowSize) * DpiF
                                    '********************************
                                    DrawArrowRight X, lTop
                                Else
                                    SetRect .ButtonRight, 0&, 0&, 0&, 0&
                                End If
                                
                                Exit For
                            End If
                        Else
                            X = X + IW + IM
                        End If
                    End If
                    
                    
                Next
                If .ItemsCount > 0 Then Y = Y + IH + IM
            End If
        End With
        If Y > UserControl.ScaleHeight Then Exit For
    Next
  
    If tSel.bInit Then 'DrawSelection
        X = tSel.pStart.X
        Y = tSel.pStart.Y - ucScrollbarV.Value
        w = tSel.pEnd.X
        h = tSel.pEnd.Y - ucScrollbarV.Value
        
        cSolidBrush.SetColor D2D1.ColorF3(&HFF1010, 0.2)
        cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(D2D1.RectF(X, Y, w, h), 0&, 0&), cSolidBrush
        
        cSolidBrush.SetColor D2D1.ColorF3(&HFF1010, 1)
        cRenderTarget.DrawRoundedRectangle D2D1.RoundedRect(D2D1.RectF(X, Y, w, h), 0&, 0&), cSolidBrush, BorderWidth, cStroke
    End If
    
    If m_BorderWidth > 0 Then
        RectF = D2D1.RectF(m_BorderWidth / 2, m_BorderWidth / 2, UserControl.ScaleWidth / DpiF - m_BorderWidth / 2, UserControl.ScaleHeight / DpiF - m_BorderWidth / 2)
        cSolidBrush.SetColor D2D1.ColorF3(m_BorderColor, 1)
        cRenderTarget.DrawRoundedRectangle D2D1.RoundedRect(RectF, m_BorderRadius, m_BorderRadius), cSolidBrush, m_BorderWidth, cStroke
    End If

    cRenderTarget.EndDraw ByVal 0&, ByVal 0&

    RaiseEvent EndPaint
    bInDraw = False
End Sub


Public Sub DrawText(ByVal sText As String, ByVal Left As Single, ByVal Top As Single, ByVal Width As Single, ByVal Height As Single, _
                    Optional HAlgin As DWRITE_TEXT_ALIGNMENT = DWRITE_TEXT_ALIGNMENT_LEADING, _
                    Optional VAlign As DWRITE_PARAGRAPH_ALIGNMENT = DWRITE_PARAGRAPH_ALIGNMENT_NEAR, _
                    Optional WordWrapping As Boolean, _
                    Optional Trimming As DWRITE_TRIMMING_GRANULARITY = DWRITE_TRIMMING_GRANULARITY_NONE)
    
    Dim DT As DWRITE_TRIMMING, IWO As IDWriteInlineObject
    Dim DT_Options As Long
    
    If Len(sText) = 0 Then Exit Sub
    
    If Trimming <> DWRITE_TRIMMING_GRANULARITY_NONE Then
        Set IWO = cDWFactory.CreateEllipsisTrimmingSign(cTextFormat)
        DT.granularity = Trimming
        cTextFormat.SetTrimming DT, IWO
    Else
        DT.granularity = DWRITE_TRIMMING_GRANULARITY_CHARACTER
        cTextFormat.SetTrimming DT, IWO
    End If
    
    cTextFormat.SetWordWrapping IIf(WordWrapping, DWRITE_WORD_WRAPPING_WRAP, DWRITE_WORD_WRAPPING_NO_WRAP)
    cTextFormat.SetTextAlignment HAlgin
    cTextFormat.SetParagraphAlignment VAlign
    
    Const D2D1_DRAW_TEXT_OPTIONS_ENABLE_COLOR_FONT = 4
    
    DT_Options = D2D1_DRAW_TEXT_OPTIONS_CLIP
    If Not IsWindows7 Then DT_Options = DT_Options Or D2D1_DRAW_TEXT_OPTIONS_ENABLE_COLOR_FONT
    
    cRenderTarget.DrawText sText, Len(sText), ByVal ObjPtr(cTextFormat), _
        D2D1.RectF(Left, Top, Left + Width, Top + Height), cTextColorBrush, _
        DT_Options, DWRITE_MEASURING_MODE_GDI_CLASSIC

    If m_Font.Strikethrough = True Or m_Font.Underline = True Then
        Dim TW As Long, TH As Long
        
        TW = Me.TextWidth(sText)
        TH = Me.TextHeight(sText)
        
        If HAlgin = DWRITE_TEXT_ALIGNMENT_CENTER Then
            Left = Left + Width / 2 - TW / 2
        ElseIf HAlgin = DWRITE_TEXT_ALIGNMENT_TRAILING Then
            Left = Left + Width - TW
        End If
        
        If VAlign = DWRITE_PARAGRAPH_ALIGNMENT_CENTER Then
            Top = Top + Height / 2 - TH / 2
        ElseIf VAlign = DWRITE_PARAGRAPH_ALIGNMENT_FAR Then
            Top = Top + Height - TH
        End If
        
        If m_Font.Strikethrough Then
            Me.DrawLine Left, Top + TH / 2, Left + TW, Top + TH / 2, Me.TextColor
        End If
        
        If m_Font.Underline Then
            Me.DrawLine Left, Top + TH, Left + TW, Top + TH, Me.TextColor
        End If
    End If
        
End Sub

'*1
Private Function CalculateGalleryHeight() As Long
    On Error Resume Next
    Dim I As Long, J As Long
    Dim X As Long, Y As Long
    Dim ItemWidth As Long
    Dim IH As Long

    Dim IM As Long
    Dim IW As Long
    
    IM = m_ItemsMargin * DpiF
    
    mClientWidth = UserControl.ScaleWidth - IIf(ucScrollbarV.Visible, ucScrollbarV.Width, 0) - DpiF * 2
    mCol = mClientWidth \ ((m_ItemsMinWidth + m_ItemsMargin) * DpiF)
    If mCol = 0 Then mCol = 1
    ItemWidth = (mClientWidth - (mCol + 1) * IM) / mCol

    Y = IM
    IH = m_ItemsHeight * DpiF

    For J = 0 To GroupCount - 1
        With tGroup(J)
            If m_GroupTitleHeight > 0 Then Y = Y + (m_GroupTitleHeight + m_ItemsMargin) * DpiF
            
            If .Collapse = False Then
                X = IM
                For I = 0 To .ItemsCount - 1
                    If m_ViewMode = VM_LIST Then
                        If I < .ItemsCount - 1 Then Y = Y + IH + IM
                    Else
                        IW = (ItemWidth) * .Items(I).Columns + IM * (.Items(I).Columns - 1)

                        If X + IW + (m_ItemsMargin + m_ItemsMinWidth / 2) * DpiF >= mClientWidth Then
                            If m_ViewMode = VM_GALLERY Then
                                X = IM
                                If I < .ItemsCount - 1 Then Y = Y + IH + IM
                            ElseIf m_ViewMode = VM_SLIDER Then
                                If .SliderPos > .ItemsCount - mCol Then .SliderPos = .ItemsCount - mCol
                                Exit For
                            End If
                        Else
                            X = X + IW + IM
                        End If
                    End If
                Next
                If .ItemsCount > 0 Then Y = Y + IH + IM
            End If
        End With
    Next
    
    CalculateGalleryHeight = Y
End Function

Private Sub Pv_ItemMouseExit()
    Dim GroupId As Variant, ItemId As Variant
    If mHotItem <> -1 And mHotItem < ItemRegionCount Then
        UserControl.MousePointer = vbDefault
        With tItemRegion(mHotItem)
            GroupId = tGroup(.GroupIndex).id
            ItemId = tGroup(.GroupIndex).Items(.Index).id
        
            With tGroup(.GroupIndex).Items(.Index)
                .bAnimate = True
                .AnimStar = Timer + mAnimateLapse
                .bIncrese = False
            End With
            TimerAnimation.Interval = 1
            
        End With
        mHotItem = -1
        UserControl.Extender.ToolTipText = ""
        UserControl.MousePointer = vbDefault
        RaiseEvent ItemMouseExit(GroupId, ItemId)
    End If
    
End Sub

Private Sub Pv_GroupMouseExit()
    On Error GoTo ErrOut
    Dim GroupId As Variant
    If mHotGroup <> -1 And mHotGroup < GroupRegionCount Then
        UserControl.MousePointer = vbDefault
        GroupId = tGroup(tGroupRegion(mHotGroup).Index).id
        
        
        With tGroup(tGroupRegion(mHotGroup).Index)
            .bAnimate = True
            .AnimStar = Timer + mAnimateLapse
            .bIncrese = False
        End With
        TimerAnimation.Interval = 1
        
        mHotGroup = -1

        RaiseEvent GroupMouseExit(GroupId)
    Else
        mHotGroup = -1
    End If
ErrOut:
End Sub

Private Sub ucScrollbarV_Change()
    'Pv_ItemMouseExit
    ucScrollbarV_Scroll

   ' RaiseEvent VerticalScroll
    If ucScrollbarV.Value = ucScrollbarV.Max Then
        RaiseEvent ScrollEnd
    End If
End Sub

Private Sub ucScrollbarV_ContainerMouseEnter()
    'RaiseEvent MouseEnter
End Sub

Private Sub ucScrollbarV_ContainerMouseLeave()
    'If bUpdate Then Draw
    'RaiseEvent MouseLeave
    If UserControl.Enabled Then Pv_ItemMouseExit
End Sub

Private Sub ucScrollbarV_OnPaint(ByVal lHdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal ePart As sbOnPaintPartCts, ByVal estate As sbOnPaintPartStateCts)
'    RaiseEvent OnScrollPaint(True, hdc, X1, Y1, X2, Y2, ePart, estate)
End Sub

Private Sub ucScrollbarV_Scroll()

    Draw
    
    Dim GroupId As Variant
    Dim ItemId As Variant
    Dim R As RECT
    If mHotGroup <> -1 And mHotGroup < GroupRegionCount Then
        If mHotItem = -1 Then
            GroupId = tGroup(tGroupRegion(mHotGroup).Index).id
            R = tGroupRegion(mHotGroup).RECT
        ElseIf mHotItem <> -1 And mHotItem < ItemRegionCount Then
            With tItemRegion(mHotItem)
                GroupId = tGroup(.GroupIndex).id
                ItemId = tGroup(.GroupIndex).Items(.Index).id
                R = .RECT
            End With
        End If
    ElseIf mHotItem <> -1 And mHotItem < ItemRegionCount Then
        With tItemRegion(mHotItem)
            GroupId = tGroup(.GroupIndex).id
            ItemId = tGroup(.GroupIndex).Items(.Index).id
            R = .RECT
        End With
    End If
    
    If m_OnHotItem = InscreaseItemSize Then
        Dim IM As Long
        IM = m_ItemsMargin '* DpiF
        R.Left = R.Left - IM / 2
        R.Top = R.Top - IM / 2
        R.right = R.right + IM / 2
        R.bottom = R.bottom + IM / 2
    End If

    RaiseEvent OnScroll(GroupId, ItemId, R.Left, R.Top, R.right - R.Left, R.bottom - R.Top)
    
End Sub

Private Sub UserControl_DblClick()
    Dim GroupId As Variant
    Dim ItemId As Variant
    
    RaiseEvent DblClick
    
    If mHotItem <> -1 Then
        GroupId = tGroup(tItemRegion(mHotItem).GroupIndex).id
        ItemId = tGroup(tItemRegion(mHotItem).GroupIndex).Items(tItemRegion(mHotItem).Index).id
        RaiseEvent ItemDblClick(GroupId, ItemId)
    End If
    
    If mHotGroup <> -1 Then
        RaiseEvent GroupDblClick(tGroup(mHotGroup).id)
    End If
    
End Sub

Public Sub Refresh()
    UserControl_Resize
End Sub

Private Sub UserControl_InitProperties()
    m_ContainerBkColor = Ambient.backColor
    m_BackColor = vbWindowBackground
    m_BorderColor = vbActiveBorder
    m_BorderWidth = 1
    m_BorderRadius = 5
    m_ItemsBackColor = vbWindowBackground
    m_ItemSelBackColor = vbActiveTitleBar
    m_ItemsShadowColor = vbBlack
    m_ItemsShadowOpacity = 50
    m_ItemsShadowSize = 5
    m_ItemsShadowOffsetX = 0
    m_ItemsShadowOffsetY = 0
    m_ItemsBorderRadius = 5
    m_ItemsBorderColor = vbActiveBorder
    m_ItemSelBorderColor = vbHighlight
    m_ItemsMargin = 20
    m_ItemsMinWidth = 150
    m_ItemsHeight = 200
    m_ViewMode = VM_GALLERY
    m_OnHotItem = InscreaseShadow
    m_DrawItemBackground = True
    m_OnHotItem = InscreaseShadow
    m_DrawItemBackground = True
    m_GroupTitleHeight = 30
    Me.TextColor = Ambient.ForeColor
    Me.Font = Ambient.Font
    UserControl.backColor = m_ContainerBkColor
    m_AnimationSpeed = AS_MEDIUM
    m_Enabled = True
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    Dim I As Long, J As Long, lStep As Long
    Dim TempIndex As Long
    
    If Shift = 0 Then
        For J = 0 To GroupCount - 1
            For I = tGroup(J).SliderPos To tGroup(J).ItemsCount - 1
                tGroup(J).Items(I).Selected = False
            Next
        Next
    End If
    
    TempIndex = mSelItem
    
    RaiseEvent KeyDown(KeyCode, Shift)
 
    If KeyCode = vbKeyRight Or KeyCode = vbKeyDown Or KeyCode = vbKeyUp Or KeyCode = vbKeyLeft Then
        If mSelGroup = -1 Then
            For I = mSelGroup + 1 To GroupCount - 1
                If tGroup(I).Collapse = False Then
                    mSelGroup = I
                    Exit For
                End If
            Next
        End If
    End If

    If KeyCode = vbKeyDown Or KeyCode = vbKeyRight Or KeyCode = vbKeyPageDown Then
        If KeyCode = vbKeyDown Then
            lStep = mCol
        ElseIf KeyCode = vbKeyRight Then
            lStep = 1
        ElseIf KeyCode = vbKeyPageDown Then
            lStep = mCol + (UserControl.ScaleHeight \ (m_ItemsHeight * DpiF) + 1)
        End If
        

        mSelItem = IIf(mSelItem = -1, 0, mSelItem + lStep)
        
        If mSelItem > tGroup(mSelGroup).ItemsCount - 1 Then
            For I = mSelGroup + 1 To GroupCount - 1
                If tGroup(I).Collapse = False Then
                    If tGroup(I).ItemsCount > 0 Then
                        mSelGroup = I
                        TempIndex = -1
                        mSelItem = 0
                        Exit For
                    End If
                End If
            Next
        End If
        If mSelItem > tGroup(mSelGroup).ItemsCount - 1 Then mSelItem = tGroup(mSelGroup).ItemsCount - 1
    
    ElseIf KeyCode = vbKeyUp Or KeyCode = vbKeyLeft Or KeyCode = vbKeyPageUp Then
        
        If KeyCode = vbKeyUp Then
            lStep = mCol
        ElseIf KeyCode = vbKeyLeft Then
            lStep = 1
        ElseIf KeyCode = vbKeyPageUp Then
            lStep = mCol + (UserControl.ScaleHeight \ (m_ItemsHeight * DpiF) + 1)
        End If
        
        mSelItem = IIf(mSelItem = -1, 0, mSelItem - lStep)
        If mSelItem < 0 Then
            For I = mSelGroup - 1 To 0 Step -1
                If tGroup(I).Collapse = False Then
                    If tGroup(I).ItemsCount > 0 Then
                        mSelGroup = I
                        TempIndex = -1
                        mSelItem = 0
                        Exit For
                    End If
                End If
            Next
        End If
        If mSelItem < 0 Then mSelItem = 0
    End If

    If KeyCode = vbKeyHome Then
        mSelItem = 0
        
        For I = 0 To GroupCount - 1
            If tGroup(I).Collapse = False Then
                If tGroup(I).ItemsCount > 0 Then
                    mSelGroup = I
                    Exit For
                End If
            End If
        Next
    ElseIf KeyCode = vbKeyEnd Then
        For I = GroupCount - 1 To 0 Step -1
            If tGroup(I).Collapse = False Then
                If tGroup(I).ItemsCount > 0 Then
                    mSelGroup = I
                    mSelItem = tGroup(I).ItemsCount - 1
                    
                    Exit For
                End If
            End If
        Next
    ElseIf KeyCode = vbKeySpace And (Shift And vbCtrlMask) = vbCtrlMask Then
        If mSelGroup <> -1 And mSelItem <> -1 Then
            tGroup(mSelGroup).Items(mSelItem).Selected = Not tGroup(mSelGroup).Items(mSelItem).Selected
            Draw
        End If
    End If
    
    If TempIndex <> mSelItem Then
    
        If (Shift And vbCtrlMask) = vbCtrlMask Then
            'tGroup(mSelGroup).Items(mSelItem).Selected = Not tGroup(mSelGroup).Items(mSelItem).Selected
        ElseIf (Shift And vbShiftMask) = vbShiftMask Then
            'lVal =
            For I = TempIndex To mSelItem Step IIf(TempIndex < mSelItem, 1, -1)
                If I < tGroup(mSelGroup).ItemsCount And I >= 0 Then
                tGroup(mSelGroup).Items(I).Selected = True
                End If
            Next
        End If
    
        If mSelGroup <> -1 Then
            EnsureVisible tGroup(mSelGroup).id, mSelItem
    
            Draw
            
            If m_ViewMode = VM_SLIDER Then
                If mSelItem = tGroup(mSelGroup).ItemsCount - 1 Then
                    RaiseEvent ScrollEnd
                End If
            End If
        End If
    End If
End Sub

Public Sub EnsureVisible(GroupId As Variant, ItemIndex As Long)
    Dim I As Long, J As Long
    Dim X As Long, Y As Long
    Dim ItemWidth As Long
    Dim IH As Long
    Dim SSZ As Long
    Dim IM As Long
    Dim IW As Long
    Dim GroupIndex As Long
  
    IM = m_ItemsMargin * DpiF
    IH = m_ItemsHeight * DpiF
    mClientWidth = UserControl.ScaleWidth - IIf(ucScrollbarV.Visible, ucScrollbarV.Width, 0) - DpiF * 2
    mCol = mClientWidth \ ((m_ItemsMinWidth + m_ItemsMargin) * DpiF)
    If mCol = 0 Then mCol = 1
    ItemWidth = (mClientWidth - (mCol + 1) * IM) / mCol
    SSZ = m_ItemsShadowSize * DpiF
    
    If Not IsEmpty(GroupId) Then
        GroupIndex = cGroup(GroupId)
    End If
    Y = IM

    For J = 0 To GroupCount - 1
        With tGroup(J)
            Y = Y + (m_GroupTitleHeight + m_ItemsMargin) * DpiF
            If .Collapse = False Then
                X = IM
                For I = 0 To .ItemsCount - 1
                
                    If m_ViewMode = VM_GALLERY Then
                        IW = (ItemWidth) * .Items(I).Columns + IM * (.Items(I).Columns - 1)
                    ElseIf m_ViewMode = VM_SLIDER Then
                        IW = ItemWidth
                    Else
                        IW = mClientWidth - IM * 2
                    End If
        
                    If J = GroupIndex And I = ItemIndex Then
             
                        If m_ViewMode = VM_SLIDER Then
                            If I < .SliderPos Then
                                .SliderPos = I - mCol + 1
                                If .SliderPos < 0 Then .SliderPos = 0
                                
                            ElseIf I > .SliderPos + mCol - 1 Then
                                .SliderPos = I - mCol + 1
                                
                            End If
                            
                        End If
                        If ucScrollbarV.Value <> Y - IM Then
                            If Y - UserControl.ScaleHeight > ucScrollbarV.Max * DpiF Then
                                ucScrollbarV.Value = ucScrollbarV.Max
                                Draw
                            Else
                                If m_ViewMode = VM_SLIDER Then
                                    ucScrollbarV.Value = Y - IM * 2 - m_GroupTitleHeight
                                    If ucScrollbarV.Value = 0 Then Draw
                                Else
                                    
                                    If Y - ucScrollbarV.Value * DpiF < 0 Then
                                        ucScrollbarV.Value = (Y - IM * 2) / DpiF
                                    ElseIf Y - ucScrollbarV.Value * DpiF + m_ItemsHeight * DpiF > UserControl.ScaleHeight Then
                                        ucScrollbarV.Value = (Y - UserControl.ScaleHeight) / DpiF + m_ItemsHeight
                                    Else
                                       Draw
                                    End If
                                End If
                            End If
                        Else
                            Draw
                        End If
                        Exit Sub
                    End If
                    
                    If m_ViewMode = VM_LIST Then
                        Y = Y + IH + IM
                        'If Y > UserControl.ScaleHeight Then Exit For
                    Else
                        If X + IW + (m_ItemsMargin + m_ItemsMinWidth / 2) * DpiF >= mClientWidth Then
                            If m_ViewMode = VM_GALLERY Then
                                X = IM
                                If I < .ItemsCount - 1 Then Y = Y + IH + IM
                                
                                'If Y > UserControl.ScaleHeight Then Exit For
                            ElseIf m_ViewMode = VM_SLIDER Then
                                'Exit For
                            End If
                        Else
                            X = X + IW + IM
                        End If
                    End If
                Next
                If .ItemsCount > 0 Then Y = Y + IH + IM
            End If
        End With
    Next
            
    Draw
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim TempIndex As Long
    Dim GroupId As Variant, ItemId As Variant, EventId As Variant
    TempIndex = mSelItem
    If TempIndex = -1 Then TempIndex = 0
    
    If mHotLabel <> -1 And mHotLabel < LE_Count Then
        With tLE(mHotLabel)
            GroupId = .GropuId
            ItemId = .ItemId
            EventId = .EventId
        End With

        RaiseEvent LabelMouseDown(GroupId, ItemId, EventId, mHotLabel)
    End If
    
    If m_MultiSelect = True Then
        If Shift = 0 Then
            Dim J As Long, I As Long
            Dim bItemSel As Boolean
            
            If mHotItem <> -1 And mHotItem < ItemRegionCount Then
                mSelItem = tItemRegion(mHotItem).Index
                mSelGroup = tItemRegion(mHotItem).GroupIndex
                bItemSel = tGroup(mSelGroup).Items(mSelItem).Selected
            End If
            
            If bItemSel = False Or Button = vbLeftButton Then
                For J = 0 To GroupCount - 1
                    If PtInRect(tGroup(J).ButtonLeft, X, Y) = 0 And PtInRect(tGroup(J).ButtonRight, X, Y) = 0 Then
                        For I = tGroup(J).SliderPos To tGroup(J).ItemsCount - 1
                            tGroup(J).Items(I).Selected = False
                        Next
                    End If
                Next
            End If
        End If
    
        If tSel.pEnd.Y <> -1 Then
            tSel.pStart.X = -1
            tSel.pStart.Y = -1
            tSel.pEnd.X = -1
            tSel.pEnd.Y = -1
            tSel.bInit = False
            
            Draw
        End If
    End If
    
    If mHotItem <> -1 And mHotItem < ItemRegionCount Then
        If m_ItemsCusorHand Then SetCursor hCurHands
        mSelItem = tItemRegion(mHotItem).Index
        mSelGroup = tItemRegion(mHotItem).GroupIndex
        If m_MultiSelect = True Then
            If (Shift And vbCtrlMask) = vbCtrlMask Then
                tGroup(mSelGroup).Items(mSelItem).Selected = Not tGroup(mSelGroup).Items(mSelItem).Selected
            ElseIf (Shift And vbShiftMask) = vbShiftMask Then
                For I = TempIndex To mSelItem Step IIf(TempIndex < mSelItem, 1, -1)
                    tGroup(mSelGroup).Items(I).Selected = True
                Next
            End If
        End If
        Draw
    End If
    
    If mHotGroup <> -1 Then
        If m_GroupTitleCusorHand Then SetCursor hCurHands
    End If
    
    If m_MultiSelect = True And mHotItem = -1 Then
        tSel.pStart.X = X / DpiF
        tSel.pStart.Y = Y / DpiF + ucScrollbarV.Value
        tSel.bInit = True
    End If
    
    RaiseEvent MouseDown(Button, Shift, X, Y)
End Sub

Private Sub Timer1_Timer()
    Dim PT As POINTAPI

    GetCursorPos PT
    ScreenToClient UserControl.hWnd, PT

    If GetKeyState(vbLeftButton) < 0 Then
        UserControl_MouseMove vbLeftButton, 0, CSng(PT.X), CSng(PT.Y)
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim I As Long, ItemId As Variant, GroupId As Variant, R As RECT
    If UserControl.Enabled = False Then Exit Sub

    X = X / DpiF
    Y = Y / DpiF
    
    For I = 0 To LE_Count - 1
         If PtInRect(tLE(I).RECT, X, Y) Then
            If tLE(I).MouseHand Then UserControl.MousePointer = vbCustom
            mLastTipText = Extender.ToolTipText
            If Len(tLE(I).TipText) Then Extender.ToolTipText = tLE(I).TipText
            mHotLabel = I
            If Button = 0 Then Draw
            Exit Sub
         End If
    Next

    If mHotLabel <> -1 Then
        Draw
        mHotLabel = -1
        If Extender.ToolTipText = mLastTipText Then
            Extender.ToolTipText = vbNullString
        Else
            Extender.ToolTipText = mLastTipText
        End If
        UserControl.MousePointer = vbDefault
    End If
    
    RaiseEvent MouseMove(Button, Shift, X, Y)
    
    If tSel.bInit Then
        tSel.pEnd.X = X
        tSel.pEnd.Y = Y + ucScrollbarV.Value

        If Y * DpiF > UserControl.ScaleHeight Then
            ucScrollbarV.Scroll_DOWN 0
            Timer1.Interval = 40
            Exit Sub
        ElseIf Y < 0 Then
            ucScrollbarV.Scroll_UP 0
            Timer1.Interval = 40
            Exit Sub
        Else
            'DrawSelection
            Draw
        End If
        
        
    End If

    
    For I = 0 To GroupRegionCount - 1
        If PtInRect(tGroupRegion(I).RECT, X, Y) Then
          
            If mHotGroup <> I Then
                If m_GroupTitleCusorHand Then UserControl.MousePointer = vbCustom ' SetCursor hCurHands
                mHotGroup = I
                GroupId = tGroup(tGroupRegion(I).Index).id
                R = tGroupRegion(I).RECT
                
                With tGroup(tGroupRegion(I).Index)
                    .bAnimate = True
                    .AnimStar = Timer + mAnimateLapse
                    .bIncrese = True
                End With
                TimerAnimation.Interval = 1
                
                'Draw
                RaiseEvent GroupMouseEnter(GroupId, R.Left, R.Top, R.right - R.Left, R.bottom - R.Top)
            End If
            
            Exit Sub
        End If
    Next
    
    Pv_GroupMouseExit
    
    For I = 0 To ItemRegionCount - 1
        If PtInRect(tItemRegion(I).RECT, X, Y) Then
            If PtInRect(tGroup(tItemRegion(I).GroupIndex).ButtonLeft, X, Y) = 0 And _
                 PtInRect(tGroup(tItemRegion(I).GroupIndex).ButtonRight, X, Y) = 0 Then
                
                If mHotItem <> I Then
                    If m_ItemsCusorHand Then UserControl.MousePointer = vbCustom ' SetCursor hCurHands
                    Pv_ItemMouseExit
                    mHotItem = I
                    With tItemRegion(I)
                        GroupId = tGroup(.GroupIndex).id
                        ItemId = tGroup(.GroupIndex).Items(.Index).id
                        UserControl.Extender.ToolTipText = tGroup(.GroupIndex).Items(.Index).TipText
                        R = .RECT
                        With tGroup(.GroupIndex).Items(.Index)
                            .bAnimate = True
                            .AnimStar = Timer + mAnimateLapse
                            .bIncrese = True
                        End With
                        TimerAnimation.Interval = 1
                    End With
                    'Draw
                    
                    'Debug.Print "ItemMouseEnter"
                    If m_OnHotItem = InscreaseItemSize Then
                        Dim IM As Long
                        IM = m_ItemsMargin '* DpiF
                        R.Left = R.Left - IM / 2
                        R.Top = R.Top - IM / 2
                        R.right = R.right + IM / 2
                        R.bottom = R.bottom + IM / 2
                    End If
                    
                    RaiseEvent ItemMouseEnter(GroupId, ItemId, R.Left - 1, R.Top - 1, R.right - R.Left + 2, R.bottom - R.Top + 2)
                    
                End If
            End If
            Exit Sub
        End If
    Next
    
    Pv_ItemMouseExit

End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim J As Long, n As Long, I As Long
    Dim xx As Long, yy As Long
    Dim T As Double
    Dim Duration As Single
    Dim Distance As Long
    Dim GroupId As Variant, ItemId As Variant, EventId As Variant
    Dim StripWidth As Long, StripHeight As Long
    Dim ItemWidth As Long
    
    If mHotLabel <> -1 And mHotLabel < LE_Count Then
        With tLE(mHotLabel)
            GroupId = .GropuId
            ItemId = .ItemId
            EventId = .EventId
        End With

        RaiseEvent LabelMouseUp(GroupId, ItemId, EventId, mHotLabel)
    End If
    
    If tSel.bInit Then
        tSel.bInit = False
        Timer1.Interval = 0
        Draw
    End If
    
    For J = 0 To GroupCount - 1
        If PtInRect(tGroup(J).ButtonLeft, X, Y) Then
            n = mCol
            Pv_ItemMouseExit
            If tGroup(J).SliderPos - n < 0 Then
                n = tGroup(J).SliderPos
            End If

            tGroup(J).SliderPos = tGroup(J).SliderPos - n

            For I = 0 To GroupRegionCount - 1
                If tGroupRegion(I).Index = J Then
                    yy = tGroupRegion(I).RECT.bottom + IIf(m_GroupTitleHeight > 0, m_ItemsMargin, 0) - m_ItemsShadowSize
                End If
            Next

            ItemWidth = (mClientWidth / DpiF - (mCol + 1) * m_ItemsMargin) / mCol
            StripWidth = (ItemWidth + m_ItemsMargin) * (mCol + n) + m_ItemsMargin ' * 2
            StripHeight = m_ItemsHeight + m_ItemsShadowSize * 2
            
            Duration = 0.3
            T = Timer + Duration
            Distance = n * (ItemWidth + m_ItemsMargin)
            
            Do While (T - Timer) > 0
                xx = -(Distance * (T - Timer) / Duration)
                PaintStrip xx, yy, StripWidth, StripHeight, J, n
            Loop

            Draw

        ElseIf PtInRect(tGroup(J).ButtonRight, X, Y) Then
    
            n = mCol
            Pv_ItemMouseExit
            If tGroup(J).SliderPos + n >= tGroup(J).ItemsCount - mCol Then
                n = tGroup(J).ItemsCount - tGroup(J).SliderPos - mCol
            End If

            For I = 0 To GroupRegionCount - 1
                If tGroupRegion(I).Index = J Then
                    yy = tGroupRegion(I).RECT.bottom + IIf(m_GroupTitleHeight > 0, m_ItemsMargin, 0) - m_ItemsShadowSize
                End If
            Next

            ItemWidth = (mClientWidth / DpiF - (mCol + 1) * m_ItemsMargin) / mCol
            StripWidth = (ItemWidth + m_ItemsMargin) * (mCol + n) + m_ItemsMargin ' * 2
            StripHeight = m_ItemsHeight + m_ItemsShadowSize * 2

            Duration = 0.3
            T = Timer + Duration
            Distance = n * (ItemWidth + m_ItemsMargin)
            
            Do While (T - Timer) > 0
                xx = -(Distance - Distance * ((T - Timer) / Duration))
                PaintStrip xx, yy, StripWidth, StripHeight, J, n
            Loop

            tGroup(J).SliderPos = tGroup(J).SliderPos + n
            Draw
            If tGroup(J).SliderPos = tGroup(J).ItemsCount - 1 - n Then
                RaiseEvent ScrollEnd
            End If
        End If
    Next

    RaiseEvent MouseUp(Button, Shift, X, Y)
    
    If mHotItem <> -1 And mHotItem < ItemRegionCount Then
        GroupId = tGroup(tItemRegion(mHotItem).GroupIndex).id
        ItemId = tGroup(tItemRegion(mHotItem).GroupIndex).Items(tItemRegion(mHotItem).Index).id
        RaiseEvent ItemClick(GroupId, ItemId)
    End If
    
    If mHotGroup <> -1 Then
        RaiseEvent GroupClick(tGroup(mHotGroup).id)
    End If
    
    
End Sub


Private Sub PaintStrip(xx As Long, yy As Long, Width As Long, Height As Long, GroupIndex As Long, nCol As Long)
    Dim lLeft As Long, lTop As Long
    Dim cSolidBrush As ID2D1SolidColorBrush
    Dim ItemWidth As Long
    Dim X As Long, Y As Long
    Dim I As Long
    Dim BorderColor As Long
    Dim BorderWidth As Long
    Dim IBkColor As Long

    cRenderTarget.BeginDraw

    Set cSolidBrush = cRenderTarget.CreateSolidColorBrush(D2D1.ColorF3(Me.backColor), ByVal 0&)
    cRenderTarget.FillRectangle D2D1.RectF(0, yy, mClientWidth, yy + Height), cSolidBrush
    '*************************************

    ItemWidth = (mClientWidth / DpiF - (mCol + 1) * m_ItemsMargin) / mCol

    With tGroup(GroupIndex)
        Y = yy + m_ItemsShadowSize
        X = m_ItemsMargin
        For I = .SliderPos To .SliderPos + mCol + nCol - 1
             
             If m_DrawItemBackground Then
             
             

                
             
             
                If m_ItemsShadowSize > 0 And m_ItemsShadowOpacity > 0 Then
                    If mIsWindows7 Then
                        If m_ItemsShadowSize > 0 And m_ItemsShadowOpacity > 0 Then
                            RenderStretch xx + X - m_ItemsShadowSize + (m_ItemsShadowOffsetX), yy + (m_ItemsShadowOffsetY), ItemWidth + m_ItemsShadowSize * 2, m_ItemsHeight + m_ItemsShadowSize * 2, 0, 0, (nSize / DpiF + m_ItemsShadowSize * 2), (nSize / DpiF + m_ItemsShadowSize * 2), (m_ItemsShadowSize * 2 + m_ItemsBorderRadius)
                        End If
                    Else
                        Dim cBitmapShadow           As ID2D1Bitmap
                        If cImageShadow Is Nothing Then
                            Set cBitmapShadow = CreateRoundRectImage((m_ItemsShadowSize) * 2.5 * DpiF, (m_ItemsShadowSize) * 2.5 * DpiF, _
                                            (ItemWidth) * DpiF, (m_ItemsHeight) * DpiF, m_ItemsBorderRadius / 2 / DpiF, vbBlack)
                                            
                                            
                            Set cImageShadow = CreateD2D1ShadowEffect(cBitmapShadow, ColorToVector_4F(m_ItemsShadowColor, 5 * m_ItemsShadowOpacity / 100), m_ItemsShadowSize)
                        End If
                    
                        cDeviceContext2.DrawImage cImageShadow, _
                            D2D1.Point2F(xx + X - m_ItemsShadowSize + m_ItemsShadowOffsetX, yy + m_ItemsShadowOffsetY), _
                            D2D1.RectF(0, 0, ItemWidth * 2, m_ItemsHeight * 2), _
                            D2D1_INTERPOLATION_MODE_LINEAR, D2D1_COMPOSITE_MODE_SOURCE_OVER
                    End If
                End If

                BorderColor = m_ItemsBorderColor
                IBkColor = m_ItemsBackColor
                BorderWidth = 1

                If m_MultiSelect Then
                    If (mSelGroup = GroupIndex And mSelItem = I) Or tGroup(GroupIndex).Items(I).Selected = True Then
                        BorderColor = m_ItemSelBorderColor
                    End If

                    If (mSelGroup = GroupIndex And mSelItem = I) Then
                        BorderWidth = 2
                    End If

                    If tGroup(GroupIndex).Items(I).Selected Then
                        IBkColor = m_ItemSelBackColor
                    End If


                Else
                    If (mSelGroup = GroupIndex And mSelItem = I) Then
                        BorderColor = m_ItemSelBorderColor
                        IBkColor = m_ItemSelBackColor
                    End If
                End If


                cSolidBrush.SetColor D2D1.ColorF3(IBkColor, 1)
                cRenderTarget.FillRoundedRectangle D2D1.RoundedRect(D2D1.RectF(xx + X, Y, xx + X + ItemWidth, Y + m_ItemsHeight), m_ItemsBorderRadius, m_ItemsBorderRadius), cSolidBrush
                
                cSolidBrush.SetColor D2D1.ColorF3(BorderColor, 0.5)
                cRenderTarget.DrawRoundedRectangle D2D1.RoundedRect(D2D1.RectF(xx + X, Y, xx + X + ItemWidth, Y + m_ItemsHeight), m_ItemsBorderRadius, m_ItemsBorderRadius), cSolidBrush, BorderWidth, cStroke

             End If
             If ItemWidth > 0 Then
             
                With mCurrentItemRect
                    .Left = xx + X
                    .Top = Y
                    .right = .Left + ItemWidth
                    .bottom = .Top + m_ItemsHeight
                End With
             
                RaiseEvent OnItemPaint(xx + X, Y, ItemWidth, m_ItemsHeight, tGroup(GroupIndex).id, tGroup(GroupIndex).Items(I).id, False, 0!)
             End If
             X = X + ItemWidth + m_ItemsMargin
        Next
    End With
    '***************************************
    lTop = yy + m_ItemsShadowSize + m_ItemsHeight / 2 - ButtonsArrowSize / 2

    lLeft = m_ItemsMargin - ButtonsArrowSize / 2
    If lLeft < 0 Then lLeft = 0
    DrawArrowLeft lLeft, lTop
    
    lLeft = mClientWidth / DpiF - m_ItemsMargin - ButtonsArrowSize / 2
    If lLeft + ButtonsArrowSize > mClientWidth / DpiF Then lLeft = mClientWidth / DpiF - ButtonsArrowSize
    DrawArrowRight lLeft, lTop
    
    cRenderTarget.EndDraw ByVal 0&, ByVal 0&
End Sub

Private Sub UserControl_Paint()
    Draw
End Sub

Private Sub UserControl_Resize()
    Dim GalleryHeight As Long
    
    If cRenderTarget Is Nothing Then Exit Sub
    
    GalleryHeight = CalculateGalleryHeight
    
    cRenderTarget.Resize D2D1.SizeU(UserControl.ScaleWidth, UserControl.ScaleHeight)
    
    If GalleryHeight > UserControl.ScaleHeight Then
        With ucScrollbarV
            .Visible = True
            .Max = Abs(GalleryHeight - UserControl.ScaleHeight) / DpiF
            .LargeChange = UserControl.ScaleHeight / 2
            .WheelChange = 20 * 3 '* DpiF
          
            .Move UserControl.ScaleWidth - ucScrollbarV.Width - m_BorderWidth * DpiF, _
               (m_BorderWidth + m_BorderRadius) * DpiF, ucScrollbarV.Width, UserControl.ScaleHeight - (m_BorderWidth + m_BorderRadius) * DpiF * 2
        End With
        If ucScrollbarV.Value >= ucScrollbarV.Max Then ucScrollbarV.Value = ucScrollbarV.Max / DpiF - 1
    Else
        ucScrollbarV.Visible = False
        ucScrollbarV.Max = 0
    End If

    Set cImageShadow = Nothing
    Draw
End Sub

Private Sub DrawArrowLeft(Left As Long, Top As Long)
    Dim cButtonBrush    As ID2D1SolidColorBrush
    Dim cStroke As ID2D1StrokeStyle
    
    Set cButtonBrush = cRenderTarget.CreateSolidColorBrush(D2D1.ColorF3(vbBlack, 0.4), ByVal 0&)
    
    cRenderTarget.FillEllipse D2D1.Ellipse(D2D1.Point2F(Left + ButtonsArrowSize / 2, Top + ButtonsArrowSize / 2), ButtonsArrowSize / 2, ButtonsArrowSize / 2), cButtonBrush
    cButtonBrush.SetColor D2D1.ColorF3(vbWhite, 1)
    
    Set cStroke = cFactory.CreateStrokeStyle(D2D1.StrokeStyleProperties(D2D1_CAP_STYLE_ROUND, _
            D2D1_CAP_STYLE_ROUND, D2D1_CAP_STYLE_FLAT, D2D1_LINE_JOIN_MITER, , D2D1_DASH_STYLE_SOLID), ByVal 0&, 0)
                    
    cRenderTarget.DrawLine Left + ButtonsArrowSize * 0.58, Top + ButtonsArrowSize / 6, Left + ButtonsArrowSize / 3, Top + ButtonsArrowSize / 2, cButtonBrush, 3, cStroke
    cRenderTarget.DrawLine Left + ButtonsArrowSize / 3, Top + ButtonsArrowSize / 2, Left + ButtonsArrowSize * 0.58, Top + ButtonsArrowSize * 0.83, cButtonBrush, 3, cStroke
End Sub

'*1
Private Sub DrawArrowRight(Left As Long, Top As Long)
    Dim cButtonBrush    As ID2D1SolidColorBrush
    Dim cStroke As ID2D1StrokeStyle
    
    Set cButtonBrush = cRenderTarget.CreateSolidColorBrush(D2D1.ColorF3(vbBlack, 0.4), ByVal 0&)
    
    cRenderTarget.FillEllipse D2D1.Ellipse(D2D1.Point2F(Left + ButtonsArrowSize / 2, Top + ButtonsArrowSize / 2), ButtonsArrowSize / 2, ButtonsArrowSize / 2), cButtonBrush
    cButtonBrush.SetColor D2D1.ColorF3(vbWhite, 1)
    
    Set cStroke = cFactory.CreateStrokeStyle(D2D1.StrokeStyleProperties(D2D1_CAP_STYLE_ROUND, _
            D2D1_CAP_STYLE_ROUND, D2D1_CAP_STYLE_FLAT, D2D1_LINE_JOIN_MITER, , D2D1_DASH_STYLE_SOLID), ByVal 0&, 0)
                    
    cRenderTarget.DrawLine Left + ButtonsArrowSize / 2.5, Top + ButtonsArrowSize / 6, Left + ButtonsArrowSize * 0.66, Top + ButtonsArrowSize / 2, cButtonBrush, 3, cStroke
    cRenderTarget.DrawLine Left + ButtonsArrowSize * 0.66, Top + ButtonsArrowSize / 2, Left + ButtonsArrowSize / 2.5, Top + ButtonsArrowSize * 0.83, cButtonBrush, 3, cStroke
End Sub

Public Function RGBtoARGB(ByVal RGBColor As Long, ByVal Opacity As Long) As Long 'By LaVople
    If (RGBColor And &H80000000) Then RGBColor = GetSysColor(RGBColor And &HFF&)
    RGBtoARGB = (RGBColor And &HFF00&) Or (RGBColor And &HFF0000) \ &H10000 Or (RGBColor And &HFF) * &H10000
    Opacity = CByte((Abs(Opacity) / 100) * 255)
    If Opacity < 128 Then
        If Opacity < 0& Then Opacity = 0&
        RGBtoARGB = RGBtoARGB Or Opacity * &H1000000
    Else
        If Opacity > 255& Then Opacity = 255&
        RGBtoARGB = RGBtoARGB Or (Opacity - 128&) * &H1000000 Or &H80000000
    End If
End Function

Public Function GetWindowsDPI() As Double
    Dim hdc As Long, lPx  As Double
    hdc = GetDC(0)
    lPx = CDbl(GetDeviceCaps(hdc, LOGPIXELSX))
    ReleaseDC 0, hdc

    If (lPx = 0) Then
        GetWindowsDPI = 1#
    Else
        GetWindowsDPI = lPx / 96#
    End If
End Function

Public Property Get RunMode() As Boolean
    On Error Resume Next
    RunMode = True
    RunMode = Ambient.UserMode
    RunMode = Extender.Parent.RunMode
End Property

Private Sub UserControl_Terminate()
    If hCurHands Then DestroyCursor hCurHands
End Sub

Private Function SizeToRectF( _
                Optional ByVal fLeft As Single, _
                Optional ByVal fTop As Single, _
                Optional ByVal fRight As Single, _
                Optional ByVal fBottom As Single) As D2D1_RECT_F
    
    With SizeToRectF
    
    .Left = fLeft
    .Top = fTop
    .right = fLeft + fRight
    .bottom = fTop + fBottom
    
    End With
    
End Function

Public Function TextWidth(ByVal sText As String) As Long
    Dim R As RECT
    DrawTextW hdc, StrPtr(sText), -1, R, DT_CALCRECT
    TextWidth = R.right / DpiF
End Function

Public Function TextHeight(ByVal sText As String) As Long
    Dim R As RECT
    DrawTextW hdc, StrPtr(sText), -1, R, DT_CALCRECT
    TextHeight = R.bottom / DpiF  ' UserControl.TextHeight(sText)
End Function

Public Property Get ContainerBkColor() As OLE_COLOR
    ContainerBkColor = m_ContainerBkColor
End Property

Public Property Let ContainerBkColor(ByVal New_Value As OLE_COLOR)
    m_ContainerBkColor = New_Value
    Call PropertyChanged("ContainerBkColor")
    UserControl.backColor = m_ContainerBkColor
    Draw
End Property

Public Property Get backColor() As OLE_COLOR
    backColor = m_BackColor
End Property

Public Property Let backColor(ByVal New_Value As OLE_COLOR)
    m_BackColor = New_Value
    PropertyChanged "BackColor"
    'UserControl.BackColor = m_BackColor

    Refresh
End Property

Public Property Get BorderColor() As OLE_COLOR
    BorderColor = m_BorderColor
End Property

Public Property Let BorderColor(ByVal New_Value As OLE_COLOR)
    m_BorderColor = New_Value
    PropertyChanged "BorderColor"
    Refresh
End Property

Public Property Get BorderWidth() As Integer
    BorderWidth = m_BorderWidth
End Property

Public Property Let BorderWidth(ByVal New_Value As Integer)
    m_BorderWidth = New_Value
    PropertyChanged "BorderWidth"
    Refresh
End Property

Public Property Get BorderRadius() As Integer
    BorderRadius = m_BorderRadius
End Property

Public Property Let BorderRadius(ByVal New_Value As Integer)
    m_BorderRadius = New_Value
    PropertyChanged "BorderRadius"
    Refresh
End Property

Public Property Get ItemsBackColor() As OLE_COLOR
    ItemsBackColor = m_ItemsBackColor
End Property

Public Property Let ItemsBackColor(ByVal New_Value As OLE_COLOR)
    m_ItemsBackColor = New_Value
    PropertyChanged "ItemsBackColor"
    Refresh
End Property

Public Property Get ItemSelBackColor() As OLE_COLOR
    ItemSelBackColor = m_ItemSelBackColor
End Property

Public Property Let ItemSelBackColor(ByVal New_Value As OLE_COLOR)
    m_ItemSelBackColor = New_Value
    PropertyChanged "ItemSelBackColor"
    Refresh
End Property

Public Property Get ItemsShadowColor() As OLE_COLOR
    ItemsShadowColor = m_ItemsShadowColor
End Property

Public Property Let ItemsShadowColor(ByVal New_Value As OLE_COLOR)
    m_ItemsShadowColor = New_Value
    PropertyChanged "ItemsShadowColor"
    Refresh
End Property

Public Property Get ItemsShadowOpacity() As Integer
    ItemsShadowOpacity = m_ItemsShadowOpacity
End Property

Public Property Let ItemsShadowOpacity(ByVal New_Value As Integer)
    m_ItemsShadowOpacity = New_Value
    PropertyChanged "ItemsShadowOpacity"
    Refresh
End Property

Public Property Get ItemsShadowSize() As Integer
    ItemsShadowSize = m_ItemsShadowSize
End Property

Public Property Let ItemsShadowSize(ByVal New_Value As Integer)
    m_ItemsShadowSize = New_Value
    PropertyChanged "ItemsShadowSize"
    Refresh
End Property

Public Property Get ItemsShadowOffsetX() As Integer
    ItemsShadowOffsetX = m_ItemsShadowOffsetX
End Property

Public Property Let ItemsShadowOffsetX(ByVal New_Value As Integer)
    m_ItemsShadowOffsetX = New_Value
    PropertyChanged "ItemsShadowOffsetX"
    Refresh
End Property

Public Property Get ItemsShadowOffsetY() As Integer
    ItemsShadowOffsetY = m_ItemsShadowOffsetY
End Property

Public Property Let ItemsShadowOffsetY(ByVal New_Value As Integer)
    m_ItemsShadowOffsetY = New_Value
    PropertyChanged "ItemsShadowOffsetY"
    Refresh
End Property

Public Property Get ItemsBorderRadius() As Integer
    ItemsBorderRadius = m_ItemsBorderRadius
End Property

Public Property Let ItemsBorderRadius(ByVal New_Value As Integer)
    m_ItemsBorderRadius = New_Value
    PropertyChanged "ItemsBorderRadius"
    Refresh
End Property

Public Property Get ItemsBorderColor() As OLE_COLOR
    ItemsBorderColor = m_ItemsBorderColor
End Property

Public Property Let ItemsBorderColor(ByVal New_Value As OLE_COLOR)
    m_ItemsBorderColor = New_Value
    PropertyChanged "ItemsBorderColor"
    Refresh
End Property

Public Property Get ItemSelBorderColor() As OLE_COLOR
    ItemSelBorderColor = m_ItemSelBorderColor
End Property

Public Property Let ItemSelBorderColor(ByVal New_Value As OLE_COLOR)
    m_ItemSelBorderColor = New_Value
    PropertyChanged "ItemSelBorderColor"
    Refresh
End Property

Public Property Get ItemsMargin() As Long
    ItemsMargin = m_ItemsMargin
End Property

Public Property Let ItemsMargin(ByVal New_Value As Long)
    m_ItemsMargin = New_Value
    PropertyChanged "ItemsMargin"
    Refresh
End Property

Public Property Get ItemsMinWidth() As Long
    ItemsMinWidth = m_ItemsMinWidth
End Property

Public Property Let ItemsMinWidth(ByVal New_Value As Long)
    m_ItemsMinWidth = New_Value
    PropertyChanged "ItemsMinWidth"
    Refresh
End Property

Public Property Get ItemsHeight() As Long
    ItemsHeight = m_ItemsHeight
End Property

Public Property Let ItemsHeight(ByVal New_Value As Long)
    m_ItemsHeight = New_Value
    PropertyChanged "ItemsHeight"
    Refresh
End Property

Public Property Get ViewMode() As Enum_ViewMode
    ViewMode = m_ViewMode
End Property

Public Property Let ViewMode(ByVal New_Value As Enum_ViewMode)
    Dim I As Long
    m_ViewMode = New_Value
    PropertyChanged "ViewMode"
    For I = 0 To GroupCount - 1
        tGroup(I).SliderPos = 0
    Next
    UserControl_Resize
End Property

Public Property Get Font() As IFont
    Set Font = m_Font
End Property

Public Property Let Font(ByVal NewValue As IFont)
    Set m_Font = NewValue
    Set UserControl.Font = NewValue
    'Set Picture1.Font = NewValue
End Property

Public Property Set Font(ByVal NewValue As StdFont)
    If Not NewValue Is m_Font Then
        Set m_Font = NewValue
        PropertyChanged "Font"
        Set UserControl.Font = NewValue
    End If
End Property

Private Sub m_Font_FontChanged(ByVal PropertyName As String)
    Dim FW As DWRITE_FONT_WEIGHT
    Dim FS As DWRITE_FONT_STYLE
    
    FW = IIf(m_Font.Bold, DWRITE_FONT_WEIGHT_BOLD, DWRITE_FONT_WEIGHT_NORMAL)
    FS = IIf(m_Font.Italic, DWRITE_FONT_STYLE_ITALIC, DWRITE_FONT_STYLE_NORMAL)
    

    Set cTextFormat = cDWFactory.CreateTextFormat(StrPtr(m_Font.Name), Nothing, FW, FS _
                                           , DWRITE_FONT_STRETCH_NORMAL, _
                                        m_Font.size * 96# / 72#, StrPtr("en-US"))
                                        
 
End Sub

Public Property Get OnHotItem() As Enum_OnHotItem
    OnHotItem = m_OnHotItem
End Property

Public Property Let OnHotItem(ByVal New_Value As Enum_OnHotItem)
    m_OnHotItem = New_Value
    PropertyChanged "OnHotItem"
    
    If m_OnHotItem = InscreaseItemSize Then
        mAnimationMax = m_ItemsMargin / 2
    ElseIf m_OnHotItem = InscreaseShadow Then
        mAnimationMax = m_ItemsShadowSize '* 1.5
    ElseIf m_OnHotItem = ColorizeBorder Then
        mAnimationMax = 255
    ElseIf m_OnHotItem = InscreaseBorder Then
        mAnimationMax = 2.5
    End If
End Property

Public Property Get DrawItemBackground() As Boolean
    DrawItemBackground = m_DrawItemBackground
End Property

Public Property Let DrawItemBackground(ByVal New_Value As Boolean)
    m_DrawItemBackground = New_Value
    PropertyChanged "DrawItemBackground"
    Refresh
End Property

Public Property Get GroupTitleHeight() As Long
    GroupTitleHeight = m_GroupTitleHeight
End Property

Public Property Let GroupTitleHeight(ByVal New_Value As Long)
    m_GroupTitleHeight = New_Value
    PropertyChanged "GroupTitleHeight"
    Refresh
End Property

Public Property Get AnimationSpeed() As eAnimationSpeed
    AnimationSpeed = m_AnimationSpeed
End Property

Public Property Let AnimationSpeed(ByVal New_Value As eAnimationSpeed)
    m_AnimationSpeed = New_Value
    Select Case m_AnimationSpeed
        Case AS_None
            mAnimateLapse = 0.001
        Case AS_FAST
            mAnimateLapse = 0.1
        Case AS_MEDIUM
            mAnimateLapse = 0.25
        Case AS_SLOW
            mAnimateLapse = 0.5
    End Select
    PropertyChanged "AnimationSpeed"
    Refresh
End Property

Public Property Get TextColor() As OLE_COLOR
    TextColor = UserControl.ForeColor
End Property

Public Property Let TextColor(ByVal New_Value As OLE_COLOR)
    UserControl.ForeColor = New_Value
    If Not cTextColorBrush Is Nothing Then
        cTextColorBrush.SetColor D2D1.ColorF3(Me.TextColor)
    End If
    PropertyChanged "TextColor"
End Property

Public Property Get Enabled() As Boolean
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
    m_Enabled = NewValue
    If Ambient.UserMode Then UserControl.Enabled = m_Enabled
    PropertyChanged "Enabled"
End Property

Public Property Get ItemsCusorHand() As Boolean
    ItemsCusorHand = m_ItemsCusorHand
End Property

Public Property Let ItemsCusorHand(ByVal NewValue As Boolean)
    m_ItemsCusorHand = NewValue
    PropertyChanged "ItemsCusorHand"
End Property

Public Property Get GroupTitleCusorHand() As Boolean
    GroupTitleCusorHand = m_GroupTitleCusorHand
End Property

Public Property Let GroupTitleCusorHand(ByVal NewValue As Boolean)
    m_GroupTitleCusorHand = NewValue
    PropertyChanged "GroupTitleCusorHand"
End Property

Public Property Get MultiSelect() As Boolean
    MultiSelect = m_MultiSelect
End Property

Public Property Let MultiSelect(ByVal NewValue As Boolean)
    m_MultiSelect = NewValue
    PropertyChanged "MultiSelect"
End Property

Public Property Get HotItem() As Long
    HotItem = mHotItem
End Property

Public Property Get HotGroup() As Long
    HotGroup = mHotGroup
End Property

Public Property Get SelItem() As Long
    SelItem = mSelItem
End Property

Public Property Get SelGroup() As Long
    SelGroup = mSelGroup
End Property

Public Property Get ItemSelected(GroupId As Variant, ItemIndex As Long) As Boolean
    Dim GroupIndex As Long
    If cGroup.Count = 0 Then
        If GroupCount = 0 Then Exit Property
        GroupIndex = 0
    Else
        GroupIndex = cGroup(GroupId)
    End If
    ItemSelected = tGroup(GroupIndex).Items(ItemIndex).Selected
End Property

Public Property Let ItemSelected(GroupId As Variant, ItemIndex As Long, NewValue As Boolean)
    Dim GroupIndex As Long
    If cGroup.Count = 0 Then
        If GroupCount = 0 Then Exit Property
        GroupIndex = 0
    Else
        GroupIndex = cGroup(GroupId)
    End If
    tGroup(GroupIndex).Items(ItemIndex).Selected = NewValue
    Draw
End Property

Public Property Get ScrollBarStyle() As sbStyleCts
    ScrollBarStyle = ucScrollbarV.Style
End Property


Public Property Let ScrollBarStyle(ByVal New_Value As sbStyleCts)
    ucScrollbarV.Style = New_Value
    If New_Value = sGoogle Then
        ucScrollbarV.Width = 8 * DpiF
        ucScrollbarV.ShowButtons = False
    Else
        ucScrollbarV.Width = 14 * DpiF
        ucScrollbarV.ShowButtons = True
    End If
    
    PropertyChanged "ScrollBarStyle"
    
    Refresh
End Property

Public Property Get Redraw() As Boolean
    Redraw = m_Redraw
End Property

Public Property Let Redraw(ByVal New_Value As Boolean)
    If New_Value = True And m_Redraw <> New_Value Then
        m_Redraw = New_Value
        Refresh
    Else
        m_Redraw = New_Value
    End If
End Property

Public Property Get LabelCaption(Index As Long) As String
    Dim sRet As String
    sRet = tLE(Index).Caption
    LabelCaption = sRet
End Property

Public Property Get LabelLeft(Index As Long) As Long
    Dim lRet As Long
    lRet = tLE(Index).RECT.Left * DpiF
    LabelLeft = lRet
End Property

Public Property Get LabelTop(Index As Long) As Long
    Dim lRet As Long
    lRet = tLE(Index).RECT.Top * DpiF
    LabelTop = lRet
End Property

Public Property Get LabelRight(Index As Long) As Long
    Dim lRet As Long
    lRet = tLE(Index).RECT.right * DpiF
    LabelRight = lRet
End Property

Public Property Get LabelBottom(Index As Long) As Long
    Dim lRet As Long
    lRet = tLE(Index).RECT.bottom * DpiF
    LabelBottom = lRet
End Property

Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

Public Property Get RenderTarget() As ID2D1HwndRenderTarget
    Set RenderTarget = cRenderTarget
End Property

Public Property Get Factory() As ID2D1Factory
    Set Factory = cFactory
End Property

Public Property Get DWFactory() As IDWriteFactory
    Set DWFactory = cDWFactory
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    With PropBag
        m_ContainerBkColor = .ReadProperty("ContainerBkColor", Ambient.backColor)
        m_BackColor = .ReadProperty("BackColor", vbWindowBackground)
        m_BorderColor = .ReadProperty("BorderColor", vbActiveBorder)
        m_BorderWidth = .ReadProperty("BorderWidth", 1)
        m_BorderRadius = .ReadProperty("BorderRadius", 5)
        m_ItemsBackColor = .ReadProperty("ItemsBackColor", vbWindowBackground)
        m_ItemSelBackColor = .ReadProperty("ItemSelBackColor", vbActiveTitleBar)
        m_ItemsShadowColor = .ReadProperty("ItemsShadowColor", vbBlack)
        m_ItemsShadowOpacity = .ReadProperty("ItemsShadowOpacity", 50)
        m_ItemsShadowSize = .ReadProperty("ItemsShadowSize", 5)
        m_ItemsShadowOffsetX = .ReadProperty("ItemsShadowOffsetX", 0)
        m_ItemsShadowOffsetY = .ReadProperty("ItemsShadowOffsetY", 0)
        m_ItemsBorderRadius = .ReadProperty("ItemsBorderRadius", 5)
        m_ItemsBorderColor = .ReadProperty("ItemsBorderColor", vbActiveBorder)
        m_ItemSelBorderColor = .ReadProperty("ItemSelBorderColor", vbHighlight)
        m_ItemsMargin = .ReadProperty("ItemsMargin", 20)
        m_ItemsMinWidth = .ReadProperty("ItemsMinWidth", 150)
        m_ItemsHeight = .ReadProperty("ItemsHeight", 200)
        m_ViewMode = .ReadProperty("ViewMode", VM_GALLERY)
        Me.OnHotItem = .ReadProperty("OnHotItem", InscreaseShadow)
        m_DrawItemBackground = .ReadProperty("DrawItemBackground", True)
        m_GroupTitleHeight = .ReadProperty("GroupTitleHeight", 30)
        Me.Font = .ReadProperty("Font", Ambient.Font)
        Me.TextColor = .ReadProperty("TextColor", Ambient.ForeColor)
        m_Enabled = .ReadProperty("Enabled", True)
        Me.ScrollBarStyle = .ReadProperty("ScrollBarStyle", sFlat)
        m_ItemsCusorHand = .ReadProperty("ItemsCusorHand", False)
        m_GroupTitleCusorHand = .ReadProperty("GroupTitleCusorHand", False)
        m_MultiSelect = .ReadProperty("MultiSelect", False)
        Me.AnimationSpeed = .ReadProperty("AnimationSpeed", AS_MEDIUM)
    End With

    If Ambient.UserMode Then
        '//Create Factorys
        Set cFactory = D2D1.CreateFactory()
        Set cDWFactory = DW.CreateFactory(DWRITE_FACTORY_TYPE_SHARED)
        Set cWICFactory = New WICImagingFactory
        
        ' // Create render target
        Set cRenderTarget = cFactory.CreateHwndRenderTarget(D2D1.RenderTargetProperties(D2D1.pixelFormat()), _
                                                          D2D1.HwndRenderTargetProperties(UserControl.hWnd, D2D1.SizeU()))
        mIsWindows7 = IsWindows7
        
        If mIsWindows7 Then
            nSize = (m_ItemsShadowSize * 4 + m_ItemsBorderRadius * 2) * DpiF
            If nSize > 0 Then
                Set cShadowBitmap = CreateRoundRectShadow(cRenderTarget, nSize, nSize, m_ItemsBorderRadius * DpiF, m_ItemsShadowColor, m_ItemsShadowOpacity / 30 / 3, m_ItemsShadowSize * DpiF)
            End If
        Else
            Set cDeviceContext2 = cRenderTarget
            Call cDeviceContext2.CreateEffect(CLSID_D2D1Shadow, m_cEffect)
        End If
        Set cSolidBrush = cRenderTarget.CreateSolidColorBrush(D2D1.ColorF(vbBlack), ByVal 0&)
        Set cTextColorBrush = cRenderTarget.CreateSolidColorBrush(D2D1.ColorF3(Me.TextColor), ByVal 0&)
        
        Set cStroke = cFactory.CreateStrokeStyle(D2D1.StrokeStyleProperties(D2D1_CAP_STYLE_ROUND, _
            D2D1_CAP_STYLE_ROUND, D2D1_CAP_STYLE_FLAT, D2D1_LINE_JOIN_MITER, , D2D1_DASH_STYLE_SOLID), ByVal 0&, 0)

        UserControl.Enabled = m_Enabled
        ucScrollbarV.TrackMouseWheelOnHwnd UserControl.hWnd
         
        UserControl.MouseIcon = GetSystemHandCursor
        
        ButtonsArrowSize = 32
        
        
         
    End If

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    With PropBag
        .WriteProperty "ContainerBkColor", m_ContainerBkColor, Ambient.backColor
        .WriteProperty "BackColor", m_BackColor, vbWindowBackground
        .WriteProperty "BorderColor", m_BorderColor, vbActiveBorder
        .WriteProperty "BorderWidth", m_BorderWidth, 1
        .WriteProperty "BorderRadius", m_BorderRadius, 5
        .WriteProperty "ItemsBackColor", m_ItemsBackColor, vbWindowBackground
        .WriteProperty "ItemSelBackColor", m_ItemSelBackColor, vbActiveTitleBar
        .WriteProperty "ItemsShadowColor", m_ItemsShadowColor, vbBlack
        .WriteProperty "ItemsShadowOpacity", m_ItemsShadowOpacity, 50
        .WriteProperty "ItemsShadowSize", m_ItemsShadowSize, 5
        .WriteProperty "ItemsShadowOffsetX", m_ItemsShadowOffsetX, 0
        .WriteProperty "ItemsShadowOffsetY", m_ItemsShadowOffsetY, 0
        .WriteProperty "ItemsBorderRadius", m_ItemsBorderRadius, 5
        .WriteProperty "ItemsBorderColor", m_ItemsBorderColor, vbActiveBorder
        .WriteProperty "ItemSelBorderColor", m_ItemSelBorderColor, vbHighlight
        .WriteProperty "ItemsMargin", m_ItemsMargin, 20
        .WriteProperty "ItemsMinWidth", m_ItemsMinWidth, 150
        .WriteProperty "ItemsHeight", m_ItemsHeight, 200
        .WriteProperty "ViewMode", m_ViewMode, VM_GALLERY
        .WriteProperty "OnHotItem", m_OnHotItem, InscreaseShadow
        .WriteProperty "DrawItemBackground", m_DrawItemBackground, True
        .WriteProperty "GroupTitleHeight", m_GroupTitleHeight, 30
        .WriteProperty "Font", m_Font, Ambient.Font
        .WriteProperty "TextColor", UserControl.ForeColor, Ambient.ForeColor
        .WriteProperty "Enabled", m_Enabled, True
        .WriteProperty "ItemsCusorHand", m_ItemsCusorHand, False
        .WriteProperty "GroupTitleCusorHand", m_GroupTitleCusorHand, False
        .WriteProperty "ScrollBarStyle", ucScrollbarV.Style, sFlat
        .WriteProperty "MultiSelect", m_MultiSelect, False
        .WriteProperty "AnimationSpeed", m_AnimationSpeed, AS_MEDIUM
    End With
End Sub


Public Sub ClipItem()
    Dim RectF As D2D1_RECT_F
    Dim cPath   As ID2D1PathGeometry
    Dim cSink   As ID2D1GeometrySink
    Dim cLayer  As ID2D1Layer
    Dim Radius As Single
    
    Radius = m_ItemsBorderRadius

    With mCurrentItemRect
        RectF.Left = .Left - 0.5
        RectF.Top = .Top - 0.5
        RectF.right = .right + 1.5
        RectF.bottom = .bottom + 1.5
    End With
    
    Set cPath = cFactory.CreatePathGeometry

    Set cSink = cPath.Open
    
    cSink.BeginFigure RectF.Left + Radius, RectF.Top, D2D1_FIGURE_BEGIN_FILLED

    cSink.AddLine RectF.right - Radius, RectF.Top
    cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.right, RectF.Top + Radius), D2D1.SizeF(Radius, Radius), 0, _
                  D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
    cSink.AddLine RectF.right, RectF.bottom - Radius
    cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.right - Radius, RectF.bottom), D2D1.SizeF(Radius, Radius), 0, _
                 D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
    cSink.AddLine RectF.Left + Radius, RectF.bottom
    cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.Left, RectF.bottom - Radius), D2D1.SizeF(Radius, Radius), 0, _
                 D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
    cSink.AddLine RectF.Left, RectF.Top + Radius
    cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.Left + Radius, RectF.Top), D2D1.SizeF(Radius, Radius), 0, _
                 D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
                 
    
    cSink.EndFigure D2D1_FIGURE_END_CLOSED
    cSink.Close

    Set cLayer = cRenderTarget.CreateLayer(ByVal 0&)
    
    cRenderTarget.PushLayer D2D1.LayerParameters(D2D1.RectF_InfiniteRect, cPath, D2D1_ANTIALIAS_MODE_PER_PRIMITIVE, _
                            D2D1.Matrix3x2F_Identity), cLayer

End Sub

Public Sub UnClipItem()
    cRenderTarget.PopLayer
End Sub

Public Sub DrawImage(ByVal Bitmap As ID2D1Bitmap, _
                Optional ByVal Left As Single, _
                Optional ByVal Top As Single, _
                Optional ByVal Width As Single, _
                Optional ByVal Height As Single, _
                Optional ByVal scaleMode As eScaleMode, _
                Optional ByVal Radius As Single)
                
    Dim RectF As D2D1_RECT_F
    Dim RectF2 As D2D1_RECT_F
    Dim lW As Long, lH As Long, lT As Long, lL As Long
    
    If Width <= 0 Then Width = Bitmap.GetSize.Width
    If Height <= 0 Then Height = Bitmap.GetSize.Height
    
    ScalePicture scaleMode, Bitmap.GetSize.Width, Bitmap.GetSize.Height, Width, Height, lW, lH, lL, lT
    
    Select Case scaleMode
    
        Case eActualSize
            RectF = D2D1.RectF(Left, Top, Left + Bitmap.GetSize.Width, Top + Bitmap.GetSize.Height)
            RectF2 = RectF
            
        Case eScale
            RectF = D2D1.RectF(Left + lL, Top + lT, Left + lL + lW, Top + lT + lH)
            RectF2 = RectF
            
        Case eScaleDown
            RectF = D2D1.RectF(Left + lL, Top + lT, Left + lL + lW, Top + lT + lH)
            RectF2 = RectF
            
        Case eScaleUp
            RectF = D2D1.RectF(Left, Top, Left + Width, Top + Height)
            RectF2 = D2D1.RectF(Left + lL, Top + lT, Left + lL + lW, Top + lT + lH)
        
        Case eStretch
            RectF = D2D1.RectF(Left, Top, Left + Width, Top + Height)
            RectF2 = RectF
    End Select
    

    If Radius > 0 Then
        Dim cPath   As ID2D1PathGeometry
        Dim cSink   As ID2D1GeometrySink
        Dim cLayer  As ID2D1Layer
     
        
        Set cPath = cFactory.CreatePathGeometry
    
        Set cSink = cPath.Open
        
        cSink.BeginFigure RectF.Left + Radius, RectF.Top, D2D1_FIGURE_BEGIN_FILLED
    
        cSink.AddLine RectF.right - Radius, RectF.Top
        cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.right, RectF.Top + Radius), D2D1.SizeF(Radius, Radius), 0, _
                      D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
        cSink.AddLine RectF.right, RectF.bottom - Radius
        cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.right - Radius, RectF.bottom), D2D1.SizeF(Radius, Radius), 0, _
                     D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
        cSink.AddLine RectF.Left + Radius, RectF.bottom
        cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.Left, RectF.bottom - Radius), D2D1.SizeF(Radius, Radius), 0, _
                     D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
        cSink.AddLine RectF.Left, RectF.Top + Radius
        cSink.AddArc D2D1.ArcSegment(D2D1.Point2F(RectF.Left + Radius, RectF.Top), D2D1.SizeF(Radius, Radius), 0, _
                     D2D1_SWEEP_DIRECTION_CLOCKWISE, D2D1_ARC_SIZE_SMALL)
                     
        
        cSink.EndFigure D2D1_FIGURE_END_CLOSED
        
        cSink.Close

        Set cLayer = cRenderTarget.CreateLayer(ByVal 0&)
        
        cRenderTarget.PushLayer D2D1.LayerParameters(D2D1.RectF_InfiniteRect, cPath, D2D1_ANTIALIAS_MODE_PER_PRIMITIVE, _
                                D2D1.Matrix3x2F_Identity), cLayer
        
        
        
        cRenderTarget.DrawBitmap Bitmap, RectF2, 1, D2D1_BITMAP_INTERPOLATION_MODE_LINEAR, ByVal 0&

        cRenderTarget.PopLayer
    
    Else
        cRenderTarget.DrawBitmap Bitmap, RectF2, 1, D2D1_BITMAP_INTERPOLATION_MODE_LINEAR, ByVal 0&

    End If

End Sub


Private Function ScalePicture( _
       ByVal eScaleMode As eScaleMode, _
       ByVal lSrcWidth As Long, _
       ByVal lSrcHeight As Long, _
       ByVal lDstWidth As Long, _
       ByVal lDstHeight As Long, _
       ByRef lNewWidth As Long, _
       ByRef lNewHeight As Long, _
       ByRef lNewLeft As Long, _
       ByRef lNewTop As Long)

    Dim dHRatio As Double
    Dim dVRatio As Double
    Dim dRatio  As Double
    
    dHRatio = lSrcWidth / lDstWidth
    dVRatio = lSrcHeight / lDstHeight
     
    Select Case eScaleMode
        Case eActualSize
            lNewWidth = lSrcWidth
            lNewHeight = lSrcHeight
        Case eStretch
            lNewWidth = lDstWidth
            lNewHeight = lDstHeight
        Case eScaleDown
            If dHRatio > 1 Or dVRatio > 1 Then
                If dHRatio > dVRatio Then
                    dRatio = dHRatio
                Else
                    dRatio = dVRatio
                End If
            Else
                lNewWidth = lSrcWidth
                lNewHeight = lSrcHeight
            End If
        Case eScale
            If dHRatio > dVRatio Then
                dRatio = dHRatio
            Else
                dRatio = dVRatio
            End If
        Case eScaleUp
            If dHRatio < dVRatio Then
                dRatio = dHRatio
            Else
                dRatio = dVRatio
            End If
    End Select
    
    If Not dRatio = 0 Then
        lNewWidth = lSrcWidth / dRatio
        lNewHeight = lSrcHeight / dRatio
    End If
    
    lNewLeft = (lDstWidth - lNewWidth) / 2
    lNewTop = (lDstHeight - lNewHeight) / 2
End Function

'*1
Public Function LoadImage(SrcImg As Variant, Optional ByVal Async As Boolean, _
                            Optional ByVal ImageID As Variant, _
                            Optional ByVal SrcNoImg As Variant) As ID2D1Bitmap
    Dim hImage As Long
    Dim DataArr() As Byte
    
    Dim cDecoder        As IWICBitmapDecoder
    Dim cFrameDecode    As IWICBitmapFrameDecode
    Dim cConverter      As IWICFormatConverter
    Dim cWICBitmap      As IWICBitmap
    
    Select Case VarType(SrcImg)
        Case vbString
            If PathIsURL(SrcImg) Then
            
                If Left$(LCase(SrcImg), 5) = "data:" Then
                    Base64Decode Split(SrcImg, ",")(1), DataArr
                    Set LoadImage = LoadImageFromArray(DataArr)
                Else
                    If Async = True Then
                        On Error Resume Next
                        UserControl.CancelAsyncRead ImageID
                        AsyncRead SrcImg, vbAsyncTypeByteArray, ImageID, vbAsyncReadForceUpdate
                        On Error GoTo 0
 
                        If Not IsMissing(SrcNoImg) Then
                            Set LoadImage = Me.LoadImage(SrcNoImg)
                        End If
                    Else
                        Dim oXMLHTTP As Object
                        Set oXMLHTTP = CreateObject("Microsoft.XMLHTTP")
    
                        oXMLHTTP.Open "GET", SrcImg, False
                        oXMLHTTP.send
    
                        If oXMLHTTP.Status = 200 Then
                            DataArr() = oXMLHTTP.responseBody
                            Set LoadImage = LoadImageFromArray(DataArr)
                        Else
                            If Not IsMissing(SrcNoImg) Then
                                Set LoadImage = Me.LoadImage(SrcNoImg)
                            End If
                        End If
                     End If
                End If
            Else
                Set cDecoder = cWICFactory.CreateDecoderFromFilename(StrPtr(SrcImg), UUID_NULL, GENERIC_READ, WICDecodeMetadataCacheOnDemand)
                Call cDecoder.GetFrame(0&, cFrameDecode)
                Call cWICFactory.CreateFormatConverter(cConverter)
                cConverter.Initialize cFrameDecode, GUID_WICPixelFormat32bppPBGRA, WICBitmapDitherTypeNone, Nothing, 0, WICBitmapPaletteTypeCustom
                Set LoadImage = cRenderTarget.CreateBitmapFromWicBitmap(ByVal ObjPtr(cConverter), ByVal 0&)
            End If

        Case vbLong
            'Dim hBmp As Long
            'Dim IIF As ICONINFO
            Dim tBmp As Bitmap
            
            If GetObjectType(SrcImg) = OBJ_BITMAP Then
                If GetObject(SrcImg, Len(tBmp), tBmp) Then
                    'no prove con estas imagenes
                    'If tBmp.bmBitsPixel = 32 And tBmp.bmBits > 0 Then
                    '    GdipCreateBitmapFromScan0 tBmp.bmWidth, tBmp.bmHeight, tBmp.bmWidthBytes, PixelFormat32bppPARGB, tBmp.bmBits, hImage1
                    '    GdipImageRotateFlip hImage1, RotateNoneFlipY
                    'Else
                        'Call GdipCreateBitmapFromHBITMAP(SrcImg, 0, hImage1)
                        Call cWICFactory.CreateBitmapFromHBITMAP(SrcImg, 0&, WICBitmapUsePremultipliedAlpha, cWICBitmap)
                    'End If
                End If
            Else
'                If TypeName(SrcImg) = "Long" Then
'                    GetIconInfo SrcImg, IIF
'                    hBmp = CopyImage(IIF.hbmColor, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION Or &H2)
'                    Call GetObject(hBmp, Len(tBmp), tBmp)
'                    GdipCreateBitmapFromScan0 tBmp.bmWidth, tBmp.bmHeight, tBmp.bmWidthBytes, PixelFormat32bppPARGB, tBmp.bmBits, hImage1
'                    GdipImageRotateFlip hImage1, RotateNoneFlipY
'                    DeleteObject hBmp
'                    DeleteObject IIF.hbmColor
'                    DeleteObject IIF.hbmMask
'                Else
                    'GdipCreateBitmapFromHICON SrcImg, hImage1
                    Call cWICFactory.CreateBitmapFromHICON(SrcImg, cWICBitmap)
                'End If
            End If
            
            Call cWICFactory.CreateFormatConverter(cConverter)
            cConverter.Initialize cWICBitmap, GUID_WICPixelFormat32bppPBGRA, WICBitmapDitherTypeNone, Nothing, 0, WICBitmapPaletteTypeMedianCut
            Set LoadImage = cRenderTarget.CreateBitmapFromWicBitmap(ByVal ObjPtr(cConverter), ByVal 0&)
        
            
            
        Case vbDataObject
            'Call GdipLoadImageFromStream(SrcImg, hImage1)
            
            'no testeado
             Set cDecoder = cWICFactory.CreateDecoderFromStream(SrcImg, UUID_NULL, WICDecodeMetadataCacheOnLoad)
             Call cDecoder.GetFrame(0, cFrameDecode)
             Call cWICFactory.CreateFormatConverter(cConverter)
             cConverter.Initialize cFrameDecode, GUID_WICPixelFormat32bppPBGRA, WICBitmapDitherTypeNone, Nothing, 0, WICBitmapPaletteTypeMedianCut
             Set LoadImage = cRenderTarget.CreateBitmapFromWicBitmap(ByVal ObjPtr(cConverter), ByVal 0&)
    
         
        Case (vbArray Or vbByte)
            DataArr() = SrcImg
            Set LoadImage = LoadImageFromArray(DataArr)
    End Select

    If hImage = 0 Then Exit Function
    
  

End Function

Private Function LoadImageFromArray(ByRef bvData() As Byte) As ID2D1Bitmap
    On Local Error GoTo LoadImageFromArray_Error
    Dim IStream         As IStream
    Dim cDecoder        As IWICBitmapDecoder
    Dim cFrameDecode    As IWICBitmapFrameDecode
    Dim cConverter      As IWICFormatConverter
    
    If Not IsArrayDim(VarPtrArray(bvData)) Then Exit Function

    Call CreateStreamOnHGlobal(bvData(0), 0&, IStream)
    If Not IStream Is Nothing Then
        Set cDecoder = cWICFactory.CreateDecoderFromStream(IStream, UUID_NULL, WICDecodeMetadataCacheOnLoad)
        Call cDecoder.GetFrame(0, cFrameDecode)
        Call cWICFactory.CreateFormatConverter(cConverter)
        cConverter.Initialize cFrameDecode, GUID_WICPixelFormat32bppPBGRA, WICBitmapDitherTypeNone, Nothing, 0, WICBitmapPaletteTypeMedianCut
        Set LoadImageFromArray = cRenderTarget.CreateBitmapFromWicBitmap(ByVal ObjPtr(cConverter), ByVal 0&)
    End If
    Set IStream = Nothing
    
LoadImageFromArray_Error:
End Function

Private Function Base64Decode(ByVal sIn As String, ByRef bvOut() As Byte) As Boolean 'By Cocus
    Dim lLenOut As Long
    Const CRYPT_STRING_BASE64 = &H1
    Call CryptStringToBinaryA(sIn, Len(sIn), CRYPT_STRING_BASE64, 0, VarPtr(lLenOut), 0, 0)
    If lLenOut = 0 Then Exit Function
    ReDim bvOut(lLenOut - 1)
    Call CryptStringToBinaryA(sIn, Len(sIn), CRYPT_STRING_BASE64, VarPtr(bvOut(0)), VarPtr(lLenOut), 0, 0)
    Base64Decode = True
End Function

Private Function IsArrayDim(ByVal lpArray As Long) As Boolean
    Dim lAddress As Long
    Call CopyMemory(lAddress, ByVal lpArray, &H4)
    IsArrayDim = Not (lAddress = 0)
End Function

Public Function GetSystemHandCursor() As Picture
    Dim Pic As PicBmp, IPic As IPicture, GUID(0 To 3) As Long
    
    If hCurHands Then DestroyCursor hCurHands: hCurHands = 0
    
    hCurHands = LoadCursor(ByVal 0&, IDC_HAND)
     
    GUID(0) = &H7BF80980
    GUID(1) = &H101ABF32
    GUID(2) = &HAA00BB8B
    GUID(3) = &HAB0C3000
 
    With Pic
        .size = Len(Pic)
        .type = vbPicTypeIcon
        .hBmp = hCurHands
        .hPal = 0
    End With
 
    Call OleCreatePictureIndirect(Pic, GUID(0), 1, IPic)
 
    Set GetSystemHandCursor = IPic
    
End Function

Private Function ShiftColor(ByVal clrFirst As Long, ByVal clrSecond As Long, ByVal lAlpha As Long) As Long
    Dim clrFore(3)         As Byte
    Dim clrBack(3)         As Byte
    
    If (clrFirst And &H80000000) Then clrFirst = GetSysColor(clrFirst And &HFF&)
    If (clrSecond And &H80000000) Then clrSecond = GetSysColor(clrSecond And &HFF&)
  
    CopyMemory clrFore(0), clrFirst, 4
    CopyMemory clrBack(0), clrSecond, 4
  
    clrFore(0) = (clrFore(0) * lAlpha + clrBack(0) * (255 - lAlpha)) / 255
    clrFore(1) = (clrFore(1) * lAlpha + clrBack(1) * (255 - lAlpha)) / 255
    clrFore(2) = (clrFore(2) * lAlpha + clrBack(2) * (255 - lAlpha)) / 255
  
    CopyMemory ShiftColor, clrFore(0), 4
  
End Function

Public Function ChrW2(ByVal CharCode As Long) As String
  Const POW10 As Long = 2 ^ 10
  If CharCode <= &HFFFF& Then ChrW2 = ChrW$(CharCode) Else _
                              ChrW2 = ChrW$(&HD800& + (CharCode And &HFFFF&) \ POW10) & _
                                      ChrW$(&HDC00& + (CharCode And (POW10 - 1)))
End Function

Private Sub UserControl_AsyncReadComplete(AsyncProp As AsyncProperty)
    On Error GoTo PropErr
    
    Dim cBitmap As ID2D1Bitmap
    
    Set cBitmap = Me.LoadImage(AsyncProp.Value)

    If Not cBitmap Is Nothing Then
        RaiseEvent AsyncImageLoadComplete(AsyncProp.PropertyName, AsyncProp.Target, cBitmap)
    End If

    Exit Sub
PropErr:
  
End Sub


Public Function IsWindows7() As Boolean
    Dim osInfo As OSVERSIONINFO
    osInfo.dwOSVersionInfoSize = Len(osInfo)
    If GetVersionEx(osInfo) <> 0 Then
        If osInfo.dwPlatformId = VER_PLATFORM_WIN32_NT And osInfo.dwMajorVersion = VER_MAJORVERSION_WIN7 And osInfo.dwMinorVersion = VER_MINORVERSION_WIN7 Then
            IsWindows7 = True
        End If
    End If
End Function


Private Function CreateRoundRectShadow(cTarget As ID2D1HwndRenderTarget, ShadowWidth As Long, ShadowHeight As Long, _
                            ByVal Radius As Single, ShadowColor As Long, _
                            ByVal Opacity As Single, ByVal blurDepth As Long) As ID2D1Bitmap
    
    'Dim cWICFactory     As WICImagingFactory
    Dim cWICBitmap      As IWICBitmap
    Dim cMemTarget      As ID2D1RenderTarget
    Dim tRTP            As D2D1_RENDER_TARGET_PROPERTIES
    Dim tRBP            As D2D1_BITMAP_PROPERTIES
    Dim cBrush          As ID2D1SolidColorBrush
    Dim tWICRect        As WICRect
    Dim DestRect        As WICRect
    Dim lStride         As Long
    Dim lBuffSize       As Long
    Dim srcBytes()      As Byte
    Dim dBytes()        As Byte
    Dim t2xBlur         As Long
    Dim vTally()        As Long
    Dim R As Long, g As Long, b As Long
    Dim tAlpha As Long, tColumn As Long, tAvg As Long
    Dim initY As Long, initYstop As Long, initYstart As Long
    Dim X As Long, Y As Long
    
    If cFactory Is Nothing Then Exit Function
    
    If (ShadowColor And &H80000000) Then ShadowColor = GetSysColor(ShadowColor And &HFF&)

    R = ShadowColor And &HFF
    g = (ShadowColor \ &H100&) And &HFF
    b = (ShadowColor \ &H10000) And &HFF
    
    'Set cWICFactory = New WICImagingFactory
    
    Call cWICFactory.CreateBitmap(ShadowWidth, ShadowHeight, _
                                GUID_WICPixelFormat32bppPBGRA, WICBitmapCacheOnDemand, cWICBitmap)
                                
    tRTP.pixelFormat.Format = DXGI_FORMAT_B8G8R8A8_UNORM
    tRTP.pixelFormat.AlphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
    
    Set cMemTarget = cFactory.CreateWicBitmapRenderTarget(ByVal ObjPtr(cWICBitmap), tRTP)
    Set cBrush = cMemTarget.CreateSolidColorBrush(D2D1.ColorF(ShadowColor, Opacity), ByVal 0&)
    
    cMemTarget.BeginDraw
    
    cMemTarget.FillRoundedRectangle D2D1.RoundedRect(D2D1.RectF(0, 0, _
                                ShadowWidth, ShadowHeight), Radius, Radius), cBrush
                                
    cMemTarget.EndDraw ByVal 0&, ByVal 0&
    
    With tWICRect
        .Width = ShadowWidth
        .Height = ShadowHeight
    End With
    
    ReDim srcBytes(tWICRect.Width * 4 - 1&, tWICRect.Height - 1&)
    
    lStride = tWICRect.Width * 4 ' 32bppARGB!!!
    lBuffSize = tWICRect.Height * lStride
    
    cWICBitmap.CopyPixels VarPtr(tWICRect), lStride, lBuffSize, VarPtr(srcBytes(0, 0))
    
    t2xBlur = blurDepth * 2
    DestRect.Width = tWICRect.Width + t2xBlur
    DestRect.Height = tWICRect.Height + t2xBlur
    
    ReDim dBytes(DestRect.Width * 4 - 1&, DestRect.Height - 1&)
    
    
    
    tAvg = (t2xBlur + 1) * (t2xBlur + 1)    ' how many pixels are being blurred

    ReDim vTally(0 To t2xBlur)              ' number of blur columns per pixel

    For Y = 0 To tWICRect.Height + t2xBlur - 1     ' loop thru shadow dib

        FillMemory vTally(0), (t2xBlur + 1) * 4, 0  ' reset column totals

        If Y < t2xBlur Then         ' y does not exist in source
            initYstart = 0          ' use 1st row
        Else
            initYstart = Y - t2xBlur ' start n blur rows above y
        End If
        ' how may source rows can we use for blurring?
        If Y < tWICRect.Height Then initYstop = Y Else initYstop = tWICRect.Height - 1

        tAlpha = 0  ' reset alpha sum
        tColumn = 0    ' reset column counter

        ' the first n columns will all be zero
        ' only the far right blur column has values; tally them
        For initY = initYstart To initYstop
            tAlpha = tAlpha + srcBytes(3, initY)
        Next
        ' assign the right column value
        vTally(t2xBlur) = tAlpha

        For X = 3 To (tWICRect.Width - 2) * 4 - 1 Step 4
            ' loop thru each source pixel's alpha

            ' set shadow alpha using blur average
            dBytes(X, Y) = tAlpha \ tAvg
            ' and set shadow color
            Select Case dBytes(X, Y)
            Case 255
                dBytes(X - 1, Y) = R
                dBytes(X - 2, Y) = g
                dBytes(X - 3, Y) = b
            Case 0
            Case Else
                dBytes(X - 1, Y) = R * dBytes(X, Y) \ 255
                dBytes(X - 2, Y) = g * dBytes(X, Y) \ 255
                dBytes(X - 3, Y) = b * dBytes(X, Y) \ 255
            End Select
            ' remove the furthest left column's alpha sum
            tAlpha = tAlpha - vTally(tColumn)
            ' count the next column of alphas
            vTally(tColumn) = 0&
            For initY = initYstart To initYstop
                vTally(tColumn) = vTally(tColumn) + srcBytes(X + 4, initY)
            Next
            ' add the new column's sum to the overall sum
            tAlpha = tAlpha + vTally(tColumn)
            ' set the next column to be recalculated
            tColumn = (tColumn + 1) Mod (t2xBlur + 1)
        Next

        ' now to finish blurring from right edge of source
        For X = X To (tWICRect.Width + t2xBlur - 1) * 4 - 1 Step 4
            dBytes(X, Y) = tAlpha \ tAvg
            Select Case dBytes(X, Y)
            Case 255
                dBytes(X - 1, Y) = R
                dBytes(X - 2, Y) = g
                dBytes(X - 3, Y) = b
            Case 0
            Case Else
                dBytes(X - 1, Y) = R * dBytes(X, Y) \ 255
                dBytes(X - 2, Y) = g * dBytes(X, Y) \ 255
                dBytes(X - 3, Y) = b * dBytes(X, Y) \ 255
            End Select
            ' remove this column's alpha sum
            tAlpha = tAlpha - vTally(tColumn)
            ' set next column to be removed
            tColumn = (tColumn + 1) Mod (t2xBlur + 1)
        Next
    Next
    tRBP.pixelFormat.Format = DXGI_FORMAT_B8G8R8A8_UNORM
    tRBP.pixelFormat.AlphaMode = D2D1_ALPHA_MODE_PREMULTIPLIED
    Set CreateRoundRectShadow = cTarget.CreateBitmapFromWicBitmap(ByVal ObjPtr(cWICBitmap), ByVal 0&)
    Set CreateRoundRectShadow = cTarget.CreateBitmap(DestRect.Width, DestRect.Height, ByVal VarPtr(dBytes(0&, 0&)), DestRect.Width * 4, tRBP)

End Function

Private Sub DrawImageRect(ByVal DestX As Long, ByVal DestY As Long, ByVal DestW As Long, ByVal DestH As Long, _
            ByVal X As Long, ByVal Y As Long, ByVal Width As Long, ByVal Height As Long)
            
    cRenderTarget.DrawBitmap cShadowBitmap, SizeToRectF(DestX, DestY, DestW, DestH), 1, D2D1_BITMAP_INTERPOLATION_MODE_LINEAR, SizeToRectF(X, Y, Width, Height)
End Sub

Private Sub RenderStretch(ByVal DestX As Long, ByVal DestY As Long, ByVal DestW As Long, ByVal DestH As Long, _
            ByVal X As Long, ByVal Y As Long, ByVal Width As Long, ByVal Height As Long, ByVal size As Long)

    Dim Sx2 As Long
  
    Sx2 = size * 2

    DrawImageRect DestX, DestY, size, size, X, Y, size, size  'TOP_LEFT
    DrawImageRect DestX + size, DestY, DestW - Sx2, size, X + size, Y, Width - Sx2, size  'TOP_CENTER
    DrawImageRect DestX + DestW - size, DestY, size, size, X + Width - size, Y, size, size  'TOP_RIGHT
    DrawImageRect DestX, DestY + size, size, DestH - Sx2, X, Y + size, size, Height - Sx2  'MID_LEFT
    DrawImageRect DestX + size, DestY + size, DestW - Sx2, DestH - Sx2, X + size, Y + size, Width - Sx2, Height - Sx2  'MID_CENTER
    DrawImageRect DestX + DestW - size, DestY + size, size, DestH - Sx2, X + Width - size, Y + size, size, Height - Sx2  'MID_RIGHT
    DrawImageRect DestX, DestY + DestH - size, size, size, X, Y + Height - size, size, size  'BOTTOM_LEFT
    DrawImageRect DestX + size, DestY + DestH - size, DestW - Sx2, size, X + size, Y + Height - size, Width - Sx2, size  'BOTTOM_CENTER
    DrawImageRect DestX + DestW - size, DestY + DestH - size, size, size, X + Width - size, Y + Height - size, size, size  'BOTTOM_RIGHT
End Sub

